import type { ExtractPropTypes, PropType, VNode } from 'vue-demi';
import type { FloatingData } from '@visoning/vue-floating-core';
import type { PopupExposed } from '../popup';
export interface PopoverExposed extends PopupExposed {
}
export declare type PopoverArrowSlotProps = FloatingData;
export declare type CreateArrow = (props: PopoverArrowSlotProps) => VNode | null;
export declare const PopupListenersForwarder: import("@visoning/vue-utility").UseListenerForwardReturn<import("@visoning/vue-utility").WithDefaultProps<{
    readonly open: BooleanConstructor;
    readonly defaultOpen: BooleanConstructor;
    readonly disabled: BooleanConstructor;
    readonly virtualElement: PropType<import("@visoning/vue-floating-core").VirtualElement>;
    readonly appendTo: PropType<string | false | HTMLElement>;
    readonly autoUpdateOnClosed: BooleanConstructor;
    readonly offset: PropType<import("@floating-ui/core").OffsetOptions>;
    readonly shift: PropType<boolean | import("@floating-ui/core").ShiftOptions>;
    readonly flip: PropType<boolean | import("@floating-ui/core").FlipOptions>;
    readonly autoPlacement: PropType<boolean | import("@floating-ui/core").AutoPlacementOptions>;
    readonly gpuAcceleration: BooleanConstructor;
    readonly destoryedOnClosed: BooleanConstructor;
    readonly floatingProps: PropType<Record<string, any>>;
    readonly floatingWrapper: PropType<(popup: VNode<import("vue-demi").RendererNode, import("vue-demi").RendererElement, {
        [key: string]: any;
    }>) => VNode<import("vue-demi").RendererNode, import("vue-demi").RendererElement, {
        [key: string]: any;
    }>>;
    readonly popupProps: PropType<Record<string, any>>;
    readonly popupWrapper: PropType<(popup: VNode<import("vue-demi").RendererNode, import("vue-demi").RendererElement, {
        [key: string]: any;
    }>) => VNode<import("vue-demi").RendererNode, import("vue-demi").RendererElement, {
        [key: string]: any;
    }>>;
    readonly zIndex: NumberConstructor;
    readonly 'onUpdate:open': PropType<(open: boolean, info: import("@visoning/vue-floating-interactions").BaseInteractionInfo<string, Event>) => void>;
    readonly onOpen: PropType<(info: import("@visoning/vue-floating-interactions").BaseInteractionInfo<string, Event>) => void>;
    readonly onClose: PropType<(info: import("@visoning/vue-floating-interactions").BaseInteractionInfo<string, Event>) => void>;
    readonly active: Omit<{
        type: BooleanConstructor;
    }, "default"> & {
        default: false;
    };
    readonly delay: PropType<import("@visoning/vue-floating-interactions").InteractionDelay>;
    readonly interactions: Omit<{
        type: new (...args: any[]) => (false | import("@visoning/vue-floating-interactions").Interaction | import("@visoning/vue-floating-interactions").Interaction[]) & {};
    } | {
        type: () => false | import("@visoning/vue-floating-interactions").Interaction | import("@visoning/vue-floating-interactions").Interaction[];
    } | {
        type: ((new (...args: any[]) => (false | import("@visoning/vue-floating-interactions").Interaction | import("@visoning/vue-floating-interactions").Interaction[]) & {}) | (() => false | import("@visoning/vue-floating-interactions").Interaction | import("@visoning/vue-floating-interactions").Interaction[]))[];
    }, "default"> & {
        default: "hover";
    };
    readonly customInteractions: PropType<((context: import("@visoning/vue-floating-interactions").InteractionsContext<string, Event>) => import("@visoning/vue-utility").MaybeRef<import("@visoning/vue-floating-interactions").ElementProps>)[]>;
    readonly targets: PropType<HTMLElement[]>;
    readonly hoverDelay: PropType<import("@visoning/vue-floating-interactions").InteractionDelay>;
    readonly clickDelay: PropType<import("@visoning/vue-floating-interactions").InteractionDelay>;
    readonly focusDelay: PropType<import("@visoning/vue-floating-interactions").InteractionDelay>;
    readonly allowPointerEnterTarget: Omit<{
        type: BooleanConstructor;
    }, "default"> & {
        default: true;
    };
    readonly inactiveWhenClickOutside: Omit<{
        type: BooleanConstructor;
    }, "default"> & {
        default: true;
    };
    readonly 'onUpdate:active': PropType<(active: boolean, info?: import("@visoning/vue-floating-interactions").BaseInteractionInfo<string, Event>) => void>;
    readonly onActive: PropType<(info?: import("@visoning/vue-floating-interactions").BaseInteractionInfo<string, Event>) => void>;
    readonly onInactive: PropType<(info?: import("@visoning/vue-floating-interactions").BaseInteractionInfo<string, Event>) => void>;
    readonly onFloatingDataUpdate: PropType<(data: {
        x: number;
        y: number;
        strategy: import("@visoning/vue-floating-core").Strategy;
        placement: import("@visoning/vue-floating-core").Placement;
        middlewareData: {
            [x: string]: any;
            arrow?: {
                x?: number;
                y?: number;
                centerOffset: number;
            };
            autoPlacement?: {
                index?: number;
                overflows: {
                    placement: import("@visoning/vue-floating-core").Placement;
                    overflows: number[];
                }[];
            };
            flip?: {
                index?: number;
                overflows: {
                    placement: import("@visoning/vue-floating-core").Placement;
                    overflows: number[];
                }[];
            };
            hide?: {
                referenceHidden?: boolean;
                escaped?: boolean;
                referenceHiddenOffsets?: {
                    left: number;
                    top: number;
                    bottom: number;
                    right: number;
                };
                escapedOffsets?: {
                    left: number;
                    top: number;
                    bottom: number;
                    right: number;
                };
            };
            offset?: {
                x: number;
                y: number;
            };
            shift?: {
                x: number;
                y: number;
            };
        };
    }) => void>;
    readonly reference: {
        type: PropType<import("@visoning/vue-floating-core").ReferenceType>;
    };
    readonly floating: {
        type: PropType<HTMLElement>;
    };
    readonly strategy: Omit<{
        type: new (...args: any[]) => import("@visoning/vue-floating-core").Strategy & {};
    } | {
        type: () => import("@visoning/vue-floating-core").Strategy;
    } | {
        type: ((new (...args: any[]) => import("@visoning/vue-floating-core").Strategy & {}) | (() => import("@visoning/vue-floating-core").Strategy))[];
    }, "default"> & {
        default: "absolute";
    };
    readonly middleware: PropType<import("@visoning/vue-floating-core").Middleware[]>;
    readonly placement: Omit<{
        type: new (...args: any[]) => import("@visoning/vue-floating-core").Placement & {};
    } | {
        type: () => import("@visoning/vue-floating-core").Placement;
    } | {
        type: ((new (...args: any[]) => import("@visoning/vue-floating-core").Placement & {}) | (() => import("@visoning/vue-floating-core").Placement))[];
    }, "default"> & {
        default: "bottom";
    };
    readonly autoUpdate: Omit<{
        type: new (...args: any[]) => (boolean | import("@visoning/vue-floating-core").UseAutoUpdateOptions) & {};
    } | {
        type: () => boolean | import("@visoning/vue-floating-core").UseAutoUpdateOptions;
    } | {
        type: ((new (...args: any[]) => (boolean | import("@visoning/vue-floating-core").UseAutoUpdateOptions) & {}) | (() => boolean | import("@visoning/vue-floating-core").UseAutoUpdateOptions))[];
    }, "default"> & {
        default: true;
    };
}, {
    readonly open: any;
    readonly defaultOpen: false;
    readonly shift: true;
    readonly appendTo: "viewport";
}>, "onFloatingDataUpdate" | "onUpdate:open" | "onOpen" | "onClose">;
export declare const ExtendsPopupProps: Pick<import("@visoning/vue-utility").WithDefaultProps<{
    readonly open: BooleanConstructor;
    readonly defaultOpen: BooleanConstructor;
    readonly disabled: BooleanConstructor;
    readonly virtualElement: PropType<import("@visoning/vue-floating-core").VirtualElement>;
    readonly appendTo: PropType<string | false | HTMLElement>;
    readonly autoUpdateOnClosed: BooleanConstructor;
    readonly offset: PropType<import("@floating-ui/core").OffsetOptions>;
    readonly shift: PropType<boolean | import("@floating-ui/core").ShiftOptions>;
    readonly flip: PropType<boolean | import("@floating-ui/core").FlipOptions>;
    readonly autoPlacement: PropType<boolean | import("@floating-ui/core").AutoPlacementOptions>;
    readonly gpuAcceleration: BooleanConstructor;
    readonly destoryedOnClosed: BooleanConstructor;
    readonly floatingProps: PropType<Record<string, any>>;
    readonly floatingWrapper: PropType<(popup: VNode<import("vue-demi").RendererNode, import("vue-demi").RendererElement, {
        [key: string]: any;
    }>) => VNode<import("vue-demi").RendererNode, import("vue-demi").RendererElement, {
        [key: string]: any;
    }>>;
    readonly popupProps: PropType<Record<string, any>>;
    readonly popupWrapper: PropType<(popup: VNode<import("vue-demi").RendererNode, import("vue-demi").RendererElement, {
        [key: string]: any;
    }>) => VNode<import("vue-demi").RendererNode, import("vue-demi").RendererElement, {
        [key: string]: any;
    }>>;
    readonly zIndex: NumberConstructor;
    readonly 'onUpdate:open': PropType<(open: boolean, info: import("@visoning/vue-floating-interactions").BaseInteractionInfo<string, Event>) => void>;
    readonly onOpen: PropType<(info: import("@visoning/vue-floating-interactions").BaseInteractionInfo<string, Event>) => void>;
    readonly onClose: PropType<(info: import("@visoning/vue-floating-interactions").BaseInteractionInfo<string, Event>) => void>;
    readonly active: Omit<{
        type: BooleanConstructor;
    }, "default"> & {
        default: false;
    };
    readonly delay: PropType<import("@visoning/vue-floating-interactions").InteractionDelay>;
    readonly interactions: Omit<{
        type: new (...args: any[]) => (false | import("@visoning/vue-floating-interactions").Interaction | import("@visoning/vue-floating-interactions").Interaction[]) & {};
    } | {
        type: () => false | import("@visoning/vue-floating-interactions").Interaction | import("@visoning/vue-floating-interactions").Interaction[];
    } | {
        type: ((new (...args: any[]) => (false | import("@visoning/vue-floating-interactions").Interaction | import("@visoning/vue-floating-interactions").Interaction[]) & {}) | (() => false | import("@visoning/vue-floating-interactions").Interaction | import("@visoning/vue-floating-interactions").Interaction[]))[];
    }, "default"> & {
        default: "hover";
    };
    readonly customInteractions: PropType<((context: import("@visoning/vue-floating-interactions").InteractionsContext<string, Event>) => import("@visoning/vue-utility").MaybeRef<import("@visoning/vue-floating-interactions").ElementProps>)[]>;
    readonly targets: PropType<HTMLElement[]>;
    readonly hoverDelay: PropType<import("@visoning/vue-floating-interactions").InteractionDelay>;
    readonly clickDelay: PropType<import("@visoning/vue-floating-interactions").InteractionDelay>;
    readonly focusDelay: PropType<import("@visoning/vue-floating-interactions").InteractionDelay>;
    readonly allowPointerEnterTarget: Omit<{
        type: BooleanConstructor;
    }, "default"> & {
        default: true;
    };
    readonly inactiveWhenClickOutside: Omit<{
        type: BooleanConstructor;
    }, "default"> & {
        default: true;
    };
    readonly 'onUpdate:active': PropType<(active: boolean, info?: import("@visoning/vue-floating-interactions").BaseInteractionInfo<string, Event>) => void>;
    readonly onActive: PropType<(info?: import("@visoning/vue-floating-interactions").BaseInteractionInfo<string, Event>) => void>;
    readonly onInactive: PropType<(info?: import("@visoning/vue-floating-interactions").BaseInteractionInfo<string, Event>) => void>;
    readonly onFloatingDataUpdate: PropType<(data: {
        x: number;
        y: number;
        strategy: import("@visoning/vue-floating-core").Strategy;
        placement: import("@visoning/vue-floating-core").Placement;
        middlewareData: {
            [x: string]: any;
            arrow?: {
                x?: number;
                y?: number;
                centerOffset: number;
            };
            autoPlacement?: {
                index?: number;
                overflows: {
                    placement: import("@visoning/vue-floating-core").Placement;
                    overflows: number[];
                }[];
            };
            flip?: {
                index?: number;
                overflows: {
                    placement: import("@visoning/vue-floating-core").Placement;
                    overflows: number[];
                }[];
            };
            hide?: {
                referenceHidden?: boolean;
                escaped?: boolean;
                referenceHiddenOffsets?: {
                    left: number;
                    top: number;
                    bottom: number;
                    right: number;
                };
                escapedOffsets?: {
                    left: number;
                    top: number;
                    bottom: number;
                    right: number;
                };
            };
            offset?: {
                x: number;
                y: number;
            };
            shift?: {
                x: number;
                y: number;
            };
        };
    }) => void>;
    readonly reference: {
        type: PropType<import("@visoning/vue-floating-core").ReferenceType>;
    };
    readonly floating: {
        type: PropType<HTMLElement>;
    };
    readonly strategy: Omit<{
        type: new (...args: any[]) => import("@visoning/vue-floating-core").Strategy & {};
    } | {
        type: () => import("@visoning/vue-floating-core").Strategy;
    } | {
        type: ((new (...args: any[]) => import("@visoning/vue-floating-core").Strategy & {}) | (() => import("@visoning/vue-floating-core").Strategy))[];
    }, "default"> & {
        default: "absolute";
    };
    readonly middleware: PropType<import("@visoning/vue-floating-core").Middleware[]>;
    readonly placement: Omit<{
        type: new (...args: any[]) => import("@visoning/vue-floating-core").Placement & {};
    } | {
        type: () => import("@visoning/vue-floating-core").Placement;
    } | {
        type: ((new (...args: any[]) => import("@visoning/vue-floating-core").Placement & {}) | (() => import("@visoning/vue-floating-core").Placement))[];
    }, "default"> & {
        default: "bottom";
    };
    readonly autoUpdate: Omit<{
        type: new (...args: any[]) => (boolean | import("@visoning/vue-floating-core").UseAutoUpdateOptions) & {};
    } | {
        type: () => boolean | import("@visoning/vue-floating-core").UseAutoUpdateOptions;
    } | {
        type: ((new (...args: any[]) => (boolean | import("@visoning/vue-floating-core").UseAutoUpdateOptions) & {}) | (() => boolean | import("@visoning/vue-floating-core").UseAutoUpdateOptions))[];
    }, "default"> & {
        default: true;
    };
}, {
    readonly open: any;
    readonly defaultOpen: false;
    readonly shift: true;
    readonly appendTo: "viewport";
}>, "shift" | "offset" | "active" | "open" | "zIndex" | "disabled" | "reference" | "floating" | "strategy" | "autoPlacement" | "flip" | "middleware" | "placement" | "autoUpdate" | "delay" | "interactions" | "customInteractions" | "targets" | "hoverDelay" | "clickDelay" | "focusDelay" | "allowPointerEnterTarget" | "inactiveWhenClickOutside" | "onUpdate:active" | "onActive" | "onInactive" | "onFloatingDataUpdate" | "defaultOpen" | "virtualElement" | "appendTo" | "autoUpdateOnClosed" | "gpuAcceleration" | "destoryedOnClosed" | "floatingProps" | "floatingWrapper" | "popupProps" | "popupWrapper" | "onUpdate:open" | "onOpen" | "onClose">;
export declare const PopoverPropsType: {
    /**
     * support: string | () => VNode | slot
     */
    readonly title: PropType<string | (() => VNode)>;
    /**
     * support: string | () => VNode | slot
     */
    readonly content: PropType<string | (() => VNode)>;
    /**
     * The theme of the popover.
     * @default 'light'
     */
    readonly theme: PropType<"dark" | "light">;
    /**
     * The size of the popover.
     * @default 'meduim'
     */
    readonly size: PropType<"small" | "meduim">;
    /**
     * @see https://cn.vuejs.org/guide/built-ins/transition.html
     */
    readonly transitionProps: PropType<string | Record<string, any>>;
    /**
     * Whether to show arrow if set.
     * @default true
     */
    readonly showArrow: BooleanConstructor;
    /**
     * For style uniformity, we will never enable the configuration of arrow middleware,
     * you can customize arrow to make arrow more as expected.
     *
     * support: CreateArrow | slot
     */
    readonly arrow: PropType<CreateArrow>;
    /**
     * HTML attributes of node.
     */
    readonly arrowProps: PropType<Record<string, any>>;
    /**
     * HTML attributes of popover node.
     */
    readonly popoverProps: PropType<Record<string, any>>;
    /**
     * HTML attributes of popover-content node.
     */
    readonly contentProps: PropType<Record<string, any>>;
    /**
     * Custom popover node wrapper.
     */
    readonly popoverWrapper: PropType<(popup: VNode | null) => VNode>;
    readonly onFloatingDataUpdate: PropType<(data: {
        x: number;
        y: number;
        strategy: import("@visoning/vue-floating-core").Strategy;
        placement: import("@visoning/vue-floating-core").Placement;
        middlewareData: {
            [x: string]: any;
            arrow?: {
                x?: number;
                y?: number;
                centerOffset: number;
            };
            autoPlacement?: {
                index?: number;
                overflows: {
                    placement: import("@visoning/vue-floating-core").Placement;
                    overflows: number[];
                }[];
            };
            flip?: {
                index?: number;
                overflows: {
                    placement: import("@visoning/vue-floating-core").Placement;
                    overflows: number[];
                }[];
            };
            hide?: {
                referenceHidden?: boolean;
                escaped?: boolean;
                referenceHiddenOffsets?: {
                    left: number;
                    top: number;
                    bottom: number;
                    right: number;
                };
                escapedOffsets?: {
                    left: number;
                    top: number;
                    bottom: number;
                    right: number;
                };
            };
            offset?: {
                x: number;
                y: number;
            };
            shift?: {
                x: number;
                y: number;
            };
        };
    }) => void>;
    readonly 'onUpdate:open': PropType<(open: boolean, info: import("@visoning/vue-floating-interactions").BaseInteractionInfo<string, Event>) => void>;
    readonly onOpen: PropType<(info: import("@visoning/vue-floating-interactions").BaseInteractionInfo<string, Event>) => void>;
    readonly onClose: PropType<(info: import("@visoning/vue-floating-interactions").BaseInteractionInfo<string, Event>) => void>;
    readonly shift: Omit<{
        type: new (...args: any[]) => (boolean | import("@floating-ui/core").ShiftOptions) & {};
    } | {
        type: () => boolean | import("@floating-ui/core").ShiftOptions;
    } | {
        type: ((new (...args: any[]) => (boolean | import("@floating-ui/core").ShiftOptions) & {}) | (() => boolean | import("@floating-ui/core").ShiftOptions))[];
    }, "default"> & {
        default: true;
    };
    readonly offset: PropType<import("@floating-ui/core").OffsetOptions>;
    readonly active: Omit<{
        type: BooleanConstructor;
    }, "default"> & {
        default: false;
    };
    readonly open: BooleanConstructor;
    readonly zIndex: NumberConstructor;
    readonly disabled: BooleanConstructor;
    readonly reference: {
        type: PropType<import("@visoning/vue-floating-core").ReferenceType>;
    };
    readonly floating: {
        type: PropType<HTMLElement>;
    };
    readonly strategy: Omit<{
        type: new (...args: any[]) => import("@visoning/vue-floating-core").Strategy & {};
    } | {
        type: () => import("@visoning/vue-floating-core").Strategy;
    } | {
        type: ((new (...args: any[]) => import("@visoning/vue-floating-core").Strategy & {}) | (() => import("@visoning/vue-floating-core").Strategy))[];
    }, "default"> & {
        default: "absolute";
    };
    readonly autoPlacement: PropType<boolean | import("@floating-ui/core").AutoPlacementOptions>;
    readonly flip: PropType<boolean | import("@floating-ui/core").FlipOptions>;
    readonly middleware: PropType<import("@visoning/vue-floating-core").Middleware[]>;
    readonly placement: Omit<{
        type: new (...args: any[]) => import("@visoning/vue-floating-core").Placement & {};
    } | {
        type: () => import("@visoning/vue-floating-core").Placement;
    } | {
        type: ((new (...args: any[]) => import("@visoning/vue-floating-core").Placement & {}) | (() => import("@visoning/vue-floating-core").Placement))[];
    }, "default"> & {
        default: "bottom";
    };
    readonly autoUpdate: Omit<{
        type: new (...args: any[]) => (boolean | import("@visoning/vue-floating-core").UseAutoUpdateOptions) & {};
    } | {
        type: () => boolean | import("@visoning/vue-floating-core").UseAutoUpdateOptions;
    } | {
        type: ((new (...args: any[]) => (boolean | import("@visoning/vue-floating-core").UseAutoUpdateOptions) & {}) | (() => boolean | import("@visoning/vue-floating-core").UseAutoUpdateOptions))[];
    }, "default"> & {
        default: true;
    };
    readonly delay: PropType<import("@visoning/vue-floating-interactions").InteractionDelay>;
    readonly interactions: Omit<{
        type: new (...args: any[]) => (false | import("@visoning/vue-floating-interactions").Interaction | import("@visoning/vue-floating-interactions").Interaction[]) & {};
    } | {
        type: () => false | import("@visoning/vue-floating-interactions").Interaction | import("@visoning/vue-floating-interactions").Interaction[];
    } | {
        type: ((new (...args: any[]) => (false | import("@visoning/vue-floating-interactions").Interaction | import("@visoning/vue-floating-interactions").Interaction[]) & {}) | (() => false | import("@visoning/vue-floating-interactions").Interaction | import("@visoning/vue-floating-interactions").Interaction[]))[];
    }, "default"> & {
        default: "hover";
    };
    readonly customInteractions: PropType<((context: import("@visoning/vue-floating-interactions").InteractionsContext<string, Event>) => import("@visoning/vue-utility").MaybeRef<import("@visoning/vue-floating-interactions").ElementProps>)[]>;
    readonly targets: PropType<HTMLElement[]>;
    readonly hoverDelay: PropType<import("@visoning/vue-floating-interactions").InteractionDelay>;
    readonly clickDelay: PropType<import("@visoning/vue-floating-interactions").InteractionDelay>;
    readonly focusDelay: PropType<import("@visoning/vue-floating-interactions").InteractionDelay>;
    readonly allowPointerEnterTarget: Omit<{
        type: BooleanConstructor;
    }, "default"> & {
        default: true;
    };
    readonly inactiveWhenClickOutside: Omit<{
        type: BooleanConstructor;
    }, "default"> & {
        default: true;
    };
    readonly 'onUpdate:active': PropType<(active: boolean, info?: import("@visoning/vue-floating-interactions").BaseInteractionInfo<string, Event>) => void>;
    readonly onActive: PropType<(info?: import("@visoning/vue-floating-interactions").BaseInteractionInfo<string, Event>) => void>;
    readonly onInactive: PropType<(info?: import("@visoning/vue-floating-interactions").BaseInteractionInfo<string, Event>) => void>;
    readonly defaultOpen: Omit<{
        type: BooleanConstructor;
    }, "default"> & {
        default: false;
    };
    readonly virtualElement: PropType<import("@visoning/vue-floating-core").VirtualElement>;
    readonly appendTo: Omit<{
        type: new (...args: any[]) => (string | false | HTMLElement) & {};
    } | {
        type: () => string | false | HTMLElement;
    } | {
        type: ((new (...args: any[]) => (string | false | HTMLElement) & {}) | (() => string | false | HTMLElement))[];
    }, "default"> & {
        default: "viewport";
    };
    readonly autoUpdateOnClosed: BooleanConstructor;
    readonly gpuAcceleration: BooleanConstructor;
    readonly destoryedOnClosed: BooleanConstructor;
    readonly floatingProps: PropType<Record<string, any>>;
    readonly floatingWrapper: PropType<(popup: VNode<import("vue-demi").RendererNode, import("vue-demi").RendererElement, {
        [key: string]: any;
    }>) => VNode<import("vue-demi").RendererNode, import("vue-demi").RendererElement, {
        [key: string]: any;
    }>>;
    readonly popupProps: PropType<Record<string, any>>;
    readonly popupWrapper: PropType<(popup: VNode<import("vue-demi").RendererNode, import("vue-demi").RendererElement, {
        [key: string]: any;
    }>) => VNode<import("vue-demi").RendererNode, import("vue-demi").RendererElement, {
        [key: string]: any;
    }>>;
};
export declare const PopoverTransitionName = "visoning-popover";
export declare const PopoverDefaultProps: {
    readonly theme: "line";
    readonly size: "meduim";
    readonly transitionProps: "visoning-popover";
    readonly showArrow: true;
};
export declare const PopoverProps: import("@visoning/vue-utility").WithDefaultProps<{
    /**
     * support: string | () => VNode | slot
     */
    readonly title: PropType<string | (() => VNode)>;
    /**
     * support: string | () => VNode | slot
     */
    readonly content: PropType<string | (() => VNode)>;
    /**
     * The theme of the popover.
     * @default 'light'
     */
    readonly theme: PropType<"dark" | "light">;
    /**
     * The size of the popover.
     * @default 'meduim'
     */
    readonly size: PropType<"small" | "meduim">;
    /**
     * @see https://cn.vuejs.org/guide/built-ins/transition.html
     */
    readonly transitionProps: PropType<string | Record<string, any>>;
    /**
     * Whether to show arrow if set.
     * @default true
     */
    readonly showArrow: BooleanConstructor;
    /**
     * For style uniformity, we will never enable the configuration of arrow middleware,
     * you can customize arrow to make arrow more as expected.
     *
     * support: CreateArrow | slot
     */
    readonly arrow: PropType<CreateArrow>;
    /**
     * HTML attributes of node.
     */
    readonly arrowProps: PropType<Record<string, any>>;
    /**
     * HTML attributes of popover node.
     */
    readonly popoverProps: PropType<Record<string, any>>;
    /**
     * HTML attributes of popover-content node.
     */
    readonly contentProps: PropType<Record<string, any>>;
    /**
     * Custom popover node wrapper.
     */
    readonly popoverWrapper: PropType<(popup: VNode | null) => VNode>;
    readonly onFloatingDataUpdate: PropType<(data: {
        x: number;
        y: number;
        strategy: import("@visoning/vue-floating-core").Strategy;
        placement: import("@visoning/vue-floating-core").Placement;
        middlewareData: {
            [x: string]: any;
            arrow?: {
                x?: number;
                y?: number;
                centerOffset: number;
            };
            autoPlacement?: {
                index?: number;
                overflows: {
                    placement: import("@visoning/vue-floating-core").Placement;
                    overflows: number[];
                }[];
            };
            flip?: {
                index?: number;
                overflows: {
                    placement: import("@visoning/vue-floating-core").Placement;
                    overflows: number[];
                }[];
            };
            hide?: {
                referenceHidden?: boolean;
                escaped?: boolean;
                referenceHiddenOffsets?: {
                    left: number;
                    top: number;
                    bottom: number;
                    right: number;
                };
                escapedOffsets?: {
                    left: number;
                    top: number;
                    bottom: number;
                    right: number;
                };
            };
            offset?: {
                x: number;
                y: number;
            };
            shift?: {
                x: number;
                y: number;
            };
        };
    }) => void>;
    readonly 'onUpdate:open': PropType<(open: boolean, info: import("@visoning/vue-floating-interactions").BaseInteractionInfo<string, Event>) => void>;
    readonly onOpen: PropType<(info: import("@visoning/vue-floating-interactions").BaseInteractionInfo<string, Event>) => void>;
    readonly onClose: PropType<(info: import("@visoning/vue-floating-interactions").BaseInteractionInfo<string, Event>) => void>;
    readonly shift: Omit<{
        type: new (...args: any[]) => (boolean | import("@floating-ui/core").ShiftOptions) & {};
    } | {
        type: () => boolean | import("@floating-ui/core").ShiftOptions;
    } | {
        type: ((new (...args: any[]) => (boolean | import("@floating-ui/core").ShiftOptions) & {}) | (() => boolean | import("@floating-ui/core").ShiftOptions))[];
    }, "default"> & {
        default: true;
    };
    readonly offset: PropType<import("@floating-ui/core").OffsetOptions>;
    readonly active: Omit<{
        type: BooleanConstructor;
    }, "default"> & {
        default: false;
    };
    readonly open: BooleanConstructor;
    readonly zIndex: NumberConstructor;
    readonly disabled: BooleanConstructor;
    readonly reference: {
        type: PropType<import("@visoning/vue-floating-core").ReferenceType>;
    };
    readonly floating: {
        type: PropType<HTMLElement>;
    };
    readonly strategy: Omit<{
        type: new (...args: any[]) => import("@visoning/vue-floating-core").Strategy & {};
    } | {
        type: () => import("@visoning/vue-floating-core").Strategy;
    } | {
        type: ((new (...args: any[]) => import("@visoning/vue-floating-core").Strategy & {}) | (() => import("@visoning/vue-floating-core").Strategy))[];
    }, "default"> & {
        default: "absolute";
    };
    readonly autoPlacement: PropType<boolean | import("@floating-ui/core").AutoPlacementOptions>;
    readonly flip: PropType<boolean | import("@floating-ui/core").FlipOptions>;
    readonly middleware: PropType<import("@visoning/vue-floating-core").Middleware[]>;
    readonly placement: Omit<{
        type: new (...args: any[]) => import("@visoning/vue-floating-core").Placement & {};
    } | {
        type: () => import("@visoning/vue-floating-core").Placement;
    } | {
        type: ((new (...args: any[]) => import("@visoning/vue-floating-core").Placement & {}) | (() => import("@visoning/vue-floating-core").Placement))[];
    }, "default"> & {
        default: "bottom";
    };
    readonly autoUpdate: Omit<{
        type: new (...args: any[]) => (boolean | import("@visoning/vue-floating-core").UseAutoUpdateOptions) & {};
    } | {
        type: () => boolean | import("@visoning/vue-floating-core").UseAutoUpdateOptions;
    } | {
        type: ((new (...args: any[]) => (boolean | import("@visoning/vue-floating-core").UseAutoUpdateOptions) & {}) | (() => boolean | import("@visoning/vue-floating-core").UseAutoUpdateOptions))[];
    }, "default"> & {
        default: true;
    };
    readonly delay: PropType<import("@visoning/vue-floating-interactions").InteractionDelay>;
    readonly interactions: Omit<{
        type: new (...args: any[]) => (false | import("@visoning/vue-floating-interactions").Interaction | import("@visoning/vue-floating-interactions").Interaction[]) & {};
    } | {
        type: () => false | import("@visoning/vue-floating-interactions").Interaction | import("@visoning/vue-floating-interactions").Interaction[];
    } | {
        type: ((new (...args: any[]) => (false | import("@visoning/vue-floating-interactions").Interaction | import("@visoning/vue-floating-interactions").Interaction[]) & {}) | (() => false | import("@visoning/vue-floating-interactions").Interaction | import("@visoning/vue-floating-interactions").Interaction[]))[];
    }, "default"> & {
        default: "hover";
    };
    readonly customInteractions: PropType<((context: import("@visoning/vue-floating-interactions").InteractionsContext<string, Event>) => import("@visoning/vue-utility").MaybeRef<import("@visoning/vue-floating-interactions").ElementProps>)[]>;
    readonly targets: PropType<HTMLElement[]>;
    readonly hoverDelay: PropType<import("@visoning/vue-floating-interactions").InteractionDelay>;
    readonly clickDelay: PropType<import("@visoning/vue-floating-interactions").InteractionDelay>;
    readonly focusDelay: PropType<import("@visoning/vue-floating-interactions").InteractionDelay>;
    readonly allowPointerEnterTarget: Omit<{
        type: BooleanConstructor;
    }, "default"> & {
        default: true;
    };
    readonly inactiveWhenClickOutside: Omit<{
        type: BooleanConstructor;
    }, "default"> & {
        default: true;
    };
    readonly 'onUpdate:active': PropType<(active: boolean, info?: import("@visoning/vue-floating-interactions").BaseInteractionInfo<string, Event>) => void>;
    readonly onActive: PropType<(info?: import("@visoning/vue-floating-interactions").BaseInteractionInfo<string, Event>) => void>;
    readonly onInactive: PropType<(info?: import("@visoning/vue-floating-interactions").BaseInteractionInfo<string, Event>) => void>;
    readonly defaultOpen: Omit<{
        type: BooleanConstructor;
    }, "default"> & {
        default: false;
    };
    readonly virtualElement: PropType<import("@visoning/vue-floating-core").VirtualElement>;
    readonly appendTo: Omit<{
        type: new (...args: any[]) => (string | false | HTMLElement) & {};
    } | {
        type: () => string | false | HTMLElement;
    } | {
        type: ((new (...args: any[]) => (string | false | HTMLElement) & {}) | (() => string | false | HTMLElement))[];
    }, "default"> & {
        default: "viewport";
    };
    readonly autoUpdateOnClosed: BooleanConstructor;
    readonly gpuAcceleration: BooleanConstructor;
    readonly destoryedOnClosed: BooleanConstructor;
    readonly floatingProps: PropType<Record<string, any>>;
    readonly floatingWrapper: PropType<(popup: VNode<import("vue-demi").RendererNode, import("vue-demi").RendererElement, {
        [key: string]: any;
    }>) => VNode<import("vue-demi").RendererNode, import("vue-demi").RendererElement, {
        [key: string]: any;
    }>>;
    readonly popupProps: PropType<Record<string, any>>;
    readonly popupWrapper: PropType<(popup: VNode<import("vue-demi").RendererNode, import("vue-demi").RendererElement, {
        [key: string]: any;
    }>) => VNode<import("vue-demi").RendererNode, import("vue-demi").RendererElement, {
        [key: string]: any;
    }>>;
}, {
    readonly theme: "line";
    readonly size: "meduim";
    readonly transitionProps: "visoning-popover";
    readonly showArrow: true;
}>;
export declare type PopoverProps = ExtractPropTypes<typeof PopoverProps>;
