import type { VNode } from 'vue-demi';
import { BaseInteractionInfo } from '@visoning/vue-floating-interactions';
export declare const Popup: import("vue-demi").DefineComponent<import("@visoning/vue-utility").WithDefaultProps<{
    readonly open: BooleanConstructor;
    readonly defaultOpen: BooleanConstructor;
    readonly disabled: BooleanConstructor;
    readonly virtualElement: import("vue-demi").PropType<import("@visoning/vue-floating-core").VirtualElement>;
    readonly appendTo: import("vue-demi").PropType<string | false | HTMLElement>;
    readonly autoUpdateOnClosed: BooleanConstructor;
    readonly offset: import("vue-demi").PropType<import("@floating-ui/core").OffsetOptions>;
    readonly shift: import("vue-demi").PropType<boolean | import("@floating-ui/core").ShiftOptions>;
    readonly flip: import("vue-demi").PropType<boolean | import("@floating-ui/core").FlipOptions>;
    readonly autoPlacement: import("vue-demi").PropType<boolean | import("@floating-ui/core").AutoPlacementOptions>;
    readonly gpuAcceleration: BooleanConstructor;
    readonly destoryedOnClosed: BooleanConstructor;
    readonly floatingProps: import("vue-demi").PropType<Record<string, any>>;
    readonly floatingWrapper: import("vue-demi").PropType<(popup: VNode<import("vue-demi").RendererNode, import("vue-demi").RendererElement, {
        [key: string]: any;
    }>) => VNode<import("vue-demi").RendererNode, import("vue-demi").RendererElement, {
        [key: string]: any;
    }>>;
    readonly popupProps: import("vue-demi").PropType<Record<string, any>>;
    readonly popupWrapper: import("vue-demi").PropType<(popup: VNode<import("vue-demi").RendererNode, import("vue-demi").RendererElement, {
        [key: string]: any;
    }>) => VNode<import("vue-demi").RendererNode, import("vue-demi").RendererElement, {
        [key: string]: any;
    }>>;
    readonly zIndex: NumberConstructor;
    readonly 'onUpdate:open': import("vue-demi").PropType<(open: boolean, info: BaseInteractionInfo<string, Event>) => void>;
    readonly onOpen: import("vue-demi").PropType<(info: BaseInteractionInfo<string, Event>) => void>;
    readonly onClose: import("vue-demi").PropType<(info: BaseInteractionInfo<string, Event>) => void>;
    readonly active: Omit<{
        type: BooleanConstructor;
    }, "default"> & {
        default: false;
    };
    readonly delay: import("vue-demi").PropType<import("@visoning/vue-floating-interactions").InteractionDelay>;
    readonly interactions: Omit<{
        type: new (...args: any[]) => (false | import("@visoning/vue-floating-interactions").Interaction | import("@visoning/vue-floating-interactions").Interaction[]) & {};
    } | {
        type: () => false | import("@visoning/vue-floating-interactions").Interaction | import("@visoning/vue-floating-interactions").Interaction[];
    } | {
        type: ((new (...args: any[]) => (false | import("@visoning/vue-floating-interactions").Interaction | import("@visoning/vue-floating-interactions").Interaction[]) & {}) | (() => false | import("@visoning/vue-floating-interactions").Interaction | import("@visoning/vue-floating-interactions").Interaction[]))[];
    }, "default"> & {
        default: "hover";
    };
    readonly customInteractions: import("vue-demi").PropType<((context: import("@visoning/vue-floating-interactions").InteractionsContext<string, Event>) => import("@visoning/vue-utility").MaybeRef<import("@visoning/vue-floating-interactions").ElementProps>)[]>;
    readonly targets: import("vue-demi").PropType<HTMLElement[]>;
    readonly hoverDelay: import("vue-demi").PropType<import("@visoning/vue-floating-interactions").InteractionDelay>;
    readonly clickDelay: import("vue-demi").PropType<import("@visoning/vue-floating-interactions").InteractionDelay>;
    readonly focusDelay: import("vue-demi").PropType<import("@visoning/vue-floating-interactions").InteractionDelay>;
    readonly allowPointerEnterTarget: Omit<{
        type: BooleanConstructor;
    }, "default"> & {
        default: true;
    };
    readonly inactiveWhenClickOutside: Omit<{
        type: BooleanConstructor;
    }, "default"> & {
        default: true;
    };
    readonly 'onUpdate:active': import("vue-demi").PropType<(active: boolean, info?: BaseInteractionInfo<string, Event>) => void>;
    readonly onActive: import("vue-demi").PropType<(info?: BaseInteractionInfo<string, Event>) => void>;
    readonly onInactive: import("vue-demi").PropType<(info?: BaseInteractionInfo<string, Event>) => void>;
    readonly onFloatingDataUpdate: import("vue-demi").PropType<(data: {
        x: number;
        y: number;
        strategy: import("@visoning/vue-floating-core").Strategy;
        placement: import("@visoning/vue-floating-core").Placement;
        middlewareData: {
            [x: string]: any;
            arrow?: {
                x?: number;
                y?: number;
                centerOffset: number;
            };
            autoPlacement?: {
                index?: number;
                overflows: {
                    placement: import("@visoning/vue-floating-core").Placement;
                    overflows: number[];
                }[];
            };
            flip?: {
                index?: number;
                overflows: {
                    placement: import("@visoning/vue-floating-core").Placement;
                    overflows: number[];
                }[];
            };
            hide?: {
                referenceHidden?: boolean;
                escaped?: boolean;
                referenceHiddenOffsets?: {
                    left: number;
                    top: number;
                    bottom: number;
                    right: number;
                };
                escapedOffsets?: {
                    left: number;
                    top: number;
                    bottom: number;
                    right: number;
                };
            };
            offset?: {
                x: number;
                y: number;
            };
            shift?: {
                x: number;
                y: number;
            };
        };
    }) => void>;
    readonly reference: {
        type: import("vue-demi").PropType<import("@visoning/vue-floating-core").ReferenceType>;
    };
    readonly floating: {
        type: import("vue-demi").PropType<HTMLElement>;
    };
    readonly strategy: Omit<{
        type: new (...args: any[]) => import("@visoning/vue-floating-core").Strategy & {};
    } | {
        type: () => import("@visoning/vue-floating-core").Strategy;
    } | {
        type: ((new (...args: any[]) => import("@visoning/vue-floating-core").Strategy & {}) | (() => import("@visoning/vue-floating-core").Strategy))[];
    }, "default"> & {
        default: "absolute";
    };
    readonly middleware: import("vue-demi").PropType<import("@visoning/vue-floating-core").Middleware[]>;
    readonly placement: Omit<{
        type: new (...args: any[]) => import("@visoning/vue-floating-core").Placement & {};
    } | {
        type: () => import("@visoning/vue-floating-core").Placement;
    } | {
        type: ((new (...args: any[]) => import("@visoning/vue-floating-core").Placement & {}) | (() => import("@visoning/vue-floating-core").Placement))[];
    }, "default"> & {
        default: "bottom";
    };
    readonly autoUpdate: Omit<{
        type: new (...args: any[]) => (boolean | import("@visoning/vue-floating-core").UseAutoUpdateOptions) & {};
    } | {
        type: () => boolean | import("@visoning/vue-floating-core").UseAutoUpdateOptions;
    } | {
        type: ((new (...args: any[]) => (boolean | import("@visoning/vue-floating-core").UseAutoUpdateOptions) & {}) | (() => boolean | import("@visoning/vue-floating-core").UseAutoUpdateOptions))[];
    }, "default"> & {
        default: true;
    };
}, {
    readonly open: any;
    readonly defaultOpen: false;
    readonly shift: true;
    readonly appendTo: "viewport";
}>, () => VNode<import("vue-demi").RendererNode, import("vue-demi").RendererElement, {
    [key: string]: any;
}>, unknown, {}, {}, import("vue-demi").ComponentOptionsMixin, import("vue-demi").ComponentOptionsMixin, {}, string, import("vue-demi").VNodeProps & import("vue-demi").AllowedComponentProps & import("vue-demi").ComponentCustomProps, Readonly<import("vue-demi").ExtractPropTypes<import("@visoning/vue-utility").WithDefaultProps<{
    readonly open: BooleanConstructor;
    readonly defaultOpen: BooleanConstructor;
    readonly disabled: BooleanConstructor;
    readonly virtualElement: import("vue-demi").PropType<import("@visoning/vue-floating-core").VirtualElement>;
    readonly appendTo: import("vue-demi").PropType<string | false | HTMLElement>;
    readonly autoUpdateOnClosed: BooleanConstructor;
    readonly offset: import("vue-demi").PropType<import("@floating-ui/core").OffsetOptions>;
    readonly shift: import("vue-demi").PropType<boolean | import("@floating-ui/core").ShiftOptions>;
    readonly flip: import("vue-demi").PropType<boolean | import("@floating-ui/core").FlipOptions>;
    readonly autoPlacement: import("vue-demi").PropType<boolean | import("@floating-ui/core").AutoPlacementOptions>;
    readonly gpuAcceleration: BooleanConstructor;
    readonly destoryedOnClosed: BooleanConstructor;
    readonly floatingProps: import("vue-demi").PropType<Record<string, any>>;
    readonly floatingWrapper: import("vue-demi").PropType<(popup: VNode<import("vue-demi").RendererNode, import("vue-demi").RendererElement, {
        [key: string]: any;
    }>) => VNode<import("vue-demi").RendererNode, import("vue-demi").RendererElement, {
        [key: string]: any;
    }>>;
    readonly popupProps: import("vue-demi").PropType<Record<string, any>>;
    readonly popupWrapper: import("vue-demi").PropType<(popup: VNode<import("vue-demi").RendererNode, import("vue-demi").RendererElement, {
        [key: string]: any;
    }>) => VNode<import("vue-demi").RendererNode, import("vue-demi").RendererElement, {
        [key: string]: any;
    }>>;
    readonly zIndex: NumberConstructor;
    readonly 'onUpdate:open': import("vue-demi").PropType<(open: boolean, info: BaseInteractionInfo<string, Event>) => void>;
    readonly onOpen: import("vue-demi").PropType<(info: BaseInteractionInfo<string, Event>) => void>;
    readonly onClose: import("vue-demi").PropType<(info: BaseInteractionInfo<string, Event>) => void>;
    readonly active: Omit<{
        type: BooleanConstructor;
    }, "default"> & {
        default: false;
    };
    readonly delay: import("vue-demi").PropType<import("@visoning/vue-floating-interactions").InteractionDelay>;
    readonly interactions: Omit<{
        type: new (...args: any[]) => (false | import("@visoning/vue-floating-interactions").Interaction | import("@visoning/vue-floating-interactions").Interaction[]) & {};
    } | {
        type: () => false | import("@visoning/vue-floating-interactions").Interaction | import("@visoning/vue-floating-interactions").Interaction[];
    } | {
        type: ((new (...args: any[]) => (false | import("@visoning/vue-floating-interactions").Interaction | import("@visoning/vue-floating-interactions").Interaction[]) & {}) | (() => false | import("@visoning/vue-floating-interactions").Interaction | import("@visoning/vue-floating-interactions").Interaction[]))[];
    }, "default"> & {
        default: "hover";
    };
    readonly customInteractions: import("vue-demi").PropType<((context: import("@visoning/vue-floating-interactions").InteractionsContext<string, Event>) => import("@visoning/vue-utility").MaybeRef<import("@visoning/vue-floating-interactions").ElementProps>)[]>;
    readonly targets: import("vue-demi").PropType<HTMLElement[]>;
    readonly hoverDelay: import("vue-demi").PropType<import("@visoning/vue-floating-interactions").InteractionDelay>;
    readonly clickDelay: import("vue-demi").PropType<import("@visoning/vue-floating-interactions").InteractionDelay>;
    readonly focusDelay: import("vue-demi").PropType<import("@visoning/vue-floating-interactions").InteractionDelay>;
    readonly allowPointerEnterTarget: Omit<{
        type: BooleanConstructor;
    }, "default"> & {
        default: true;
    };
    readonly inactiveWhenClickOutside: Omit<{
        type: BooleanConstructor;
    }, "default"> & {
        default: true;
    };
    readonly 'onUpdate:active': import("vue-demi").PropType<(active: boolean, info?: BaseInteractionInfo<string, Event>) => void>;
    readonly onActive: import("vue-demi").PropType<(info?: BaseInteractionInfo<string, Event>) => void>;
    readonly onInactive: import("vue-demi").PropType<(info?: BaseInteractionInfo<string, Event>) => void>;
    readonly onFloatingDataUpdate: import("vue-demi").PropType<(data: {
        x: number;
        y: number;
        strategy: import("@visoning/vue-floating-core").Strategy;
        placement: import("@visoning/vue-floating-core").Placement;
        middlewareData: {
            [x: string]: any;
            arrow?: {
                x?: number;
                y?: number;
                centerOffset: number;
            };
            autoPlacement?: {
                index?: number;
                overflows: {
                    placement: import("@visoning/vue-floating-core").Placement;
                    overflows: number[];
                }[];
            };
            flip?: {
                index?: number;
                overflows: {
                    placement: import("@visoning/vue-floating-core").Placement;
                    overflows: number[];
                }[];
            };
            hide?: {
                referenceHidden?: boolean;
                escaped?: boolean;
                referenceHiddenOffsets?: {
                    left: number;
                    top: number;
                    bottom: number;
                    right: number;
                };
                escapedOffsets?: {
                    left: number;
                    top: number;
                    bottom: number;
                    right: number;
                };
            };
            offset?: {
                x: number;
                y: number;
            };
            shift?: {
                x: number;
                y: number;
            };
        };
    }) => void>;
    readonly reference: {
        type: import("vue-demi").PropType<import("@visoning/vue-floating-core").ReferenceType>;
    };
    readonly floating: {
        type: import("vue-demi").PropType<HTMLElement>;
    };
    readonly strategy: Omit<{
        type: new (...args: any[]) => import("@visoning/vue-floating-core").Strategy & {};
    } | {
        type: () => import("@visoning/vue-floating-core").Strategy;
    } | {
        type: ((new (...args: any[]) => import("@visoning/vue-floating-core").Strategy & {}) | (() => import("@visoning/vue-floating-core").Strategy))[];
    }, "default"> & {
        default: "absolute";
    };
    readonly middleware: import("vue-demi").PropType<import("@visoning/vue-floating-core").Middleware[]>;
    readonly placement: Omit<{
        type: new (...args: any[]) => import("@visoning/vue-floating-core").Placement & {};
    } | {
        type: () => import("@visoning/vue-floating-core").Placement;
    } | {
        type: ((new (...args: any[]) => import("@visoning/vue-floating-core").Placement & {}) | (() => import("@visoning/vue-floating-core").Placement))[];
    }, "default"> & {
        default: "bottom";
    };
    readonly autoUpdate: Omit<{
        type: new (...args: any[]) => (boolean | import("@visoning/vue-floating-core").UseAutoUpdateOptions) & {};
    } | {
        type: () => boolean | import("@visoning/vue-floating-core").UseAutoUpdateOptions;
    } | {
        type: ((new (...args: any[]) => (boolean | import("@visoning/vue-floating-core").UseAutoUpdateOptions) & {}) | (() => boolean | import("@visoning/vue-floating-core").UseAutoUpdateOptions))[];
    }, "default"> & {
        default: true;
    };
}, {
    readonly open: any;
    readonly defaultOpen: false;
    readonly shift: true;
    readonly appendTo: "viewport";
}>>>, {
    readonly shift: boolean | import("@floating-ui/core").ShiftOptions;
    readonly active: boolean;
    readonly open: boolean;
    readonly disabled: boolean;
    readonly strategy: import("@visoning/vue-floating-core").Strategy;
    readonly placement: import("@visoning/vue-floating-core").Placement;
    readonly autoUpdate: true;
    readonly interactions: false | import("@visoning/vue-floating-interactions").Interaction | import("@visoning/vue-floating-interactions").Interaction[];
    readonly allowPointerEnterTarget: boolean;
    readonly inactiveWhenClickOutside: boolean;
    readonly defaultOpen: boolean;
    readonly appendTo: string | false | HTMLElement;
    readonly autoUpdateOnClosed: boolean;
    readonly gpuAcceleration: boolean;
    readonly destoryedOnClosed: boolean;
}>;
