import type { ExtractPropTypes, PropType, VNode } from 'vue-demi';
import type { AutoPlacementOptions, FlipOptions, OffsetOptions, ShiftOptions } from '@floating-ui/core';
import type { FloatingType, FloatingData, ReferenceType, VirtualElement } from '@visoning/vue-floating-core';
import { BaseInteractionInfo } from '@visoning/vue-floating-interactions';
export interface PopupExposed {
    updatePosition: () => void;
    getFloatingData: () => FloatingData | undefined;
    getElements: () => {
        floating?: FloatingType | undefined | null;
        reference?: ReferenceType | undefined | null;
    };
}
export declare type PopupSlotProps = FloatingData;
export declare const FloatingCreatorListenersForwarder: import("@visoning/vue-utility").UseListenerForwardReturn<import("@visoning/vue-utility").WithDefaultProps<{
    readonly reference: {
        type: PropType<ReferenceType>;
    };
    readonly floating: {
        type: PropType<HTMLElement>;
    };
    readonly disabled: BooleanConstructor;
    readonly placement: PropType<import("@floating-ui/core").Placement>;
    readonly strategy: PropType<import("@floating-ui/core").Strategy>;
    readonly middleware: PropType<import("@floating-ui/core").Middleware[]>;
    readonly autoUpdate: PropType<boolean | import("@visoning/vue-floating-core").UseAutoUpdateOptions>;
    readonly onFloatingDataUpdate: PropType<(data: {
        x: number;
        y: number;
        strategy: import("@floating-ui/core").Strategy;
        placement: import("@floating-ui/core").Placement;
        middlewareData: {
            [x: string]: any;
            arrow?: {
                x?: number;
                y?: number;
                centerOffset: number;
            };
            autoPlacement?: {
                index?: number;
                overflows: {
                    placement: import("@floating-ui/core").Placement;
                    overflows: number[];
                }[];
            };
            flip?: {
                index?: number;
                overflows: {
                    placement: import("@floating-ui/core").Placement;
                    overflows: number[];
                }[];
            };
            hide?: {
                referenceHidden?: boolean;
                escaped?: boolean;
                referenceHiddenOffsets?: {
                    left: number;
                    top: number;
                    bottom: number;
                    right: number;
                };
                escapedOffsets?: {
                    left: number;
                    top: number;
                    bottom: number;
                    right: number;
                };
            };
            offset?: {
                x: number;
                y: number;
            };
            shift?: {
                x: number;
                y: number;
            };
        };
    }) => void>;
}, {
    readonly placement: "bottom";
    readonly strategy: "absolute";
    readonly autoUpdate: true;
}>, "onFloatingDataUpdate">;
export declare const ExtendsFloatingCreatorProps: Pick<import("@visoning/vue-utility").WithDefaultProps<{
    readonly reference: {
        type: PropType<ReferenceType>;
    };
    readonly floating: {
        type: PropType<HTMLElement>;
    };
    readonly disabled: BooleanConstructor;
    readonly placement: PropType<import("@floating-ui/core").Placement>;
    readonly strategy: PropType<import("@floating-ui/core").Strategy>;
    readonly middleware: PropType<import("@floating-ui/core").Middleware[]>;
    readonly autoUpdate: PropType<boolean | import("@visoning/vue-floating-core").UseAutoUpdateOptions>;
    readonly onFloatingDataUpdate: PropType<(data: {
        x: number;
        y: number;
        strategy: import("@floating-ui/core").Strategy;
        placement: import("@floating-ui/core").Placement;
        middlewareData: {
            [x: string]: any;
            arrow?: {
                x?: number;
                y?: number;
                centerOffset: number;
            };
            autoPlacement?: {
                index?: number;
                overflows: {
                    placement: import("@floating-ui/core").Placement;
                    overflows: number[];
                }[];
            };
            flip?: {
                index?: number;
                overflows: {
                    placement: import("@floating-ui/core").Placement;
                    overflows: number[];
                }[];
            };
            hide?: {
                referenceHidden?: boolean;
                escaped?: boolean;
                referenceHiddenOffsets?: {
                    left: number;
                    top: number;
                    bottom: number;
                    right: number;
                };
                escapedOffsets?: {
                    left: number;
                    top: number;
                    bottom: number;
                    right: number;
                };
            };
            offset?: {
                x: number;
                y: number;
            };
            shift?: {
                x: number;
                y: number;
            };
        };
    }) => void>;
}, {
    readonly placement: "bottom";
    readonly strategy: "absolute";
    readonly autoUpdate: true;
}>, "disabled" | "reference" | "floating" | "strategy" | "middleware" | "placement" | "autoUpdate" | "onFloatingDataUpdate">;
export declare const ExtendsInteractiorProps: Pick<import("@visoning/vue-utility").WithDefaultProps<{
    readonly active: BooleanConstructor;
    readonly interactions: PropType<false | import("@visoning/vue-floating-interactions").Interaction | import("@visoning/vue-floating-interactions").Interaction[]>;
    readonly customInteractions: PropType<((context: import("@visoning/vue-floating-interactions").InteractionsContext<string, Event>) => import("@visoning/vue-utility").MaybeRef<import("@visoning/vue-floating-interactions").ElementProps>)[]>;
    readonly targets: PropType<HTMLElement[]>;
    readonly delay: PropType<import("@visoning/vue-floating-interactions").InteractionDelay>;
    readonly hoverDelay: PropType<import("@visoning/vue-floating-interactions").InteractionDelay>;
    readonly clickDelay: PropType<import("@visoning/vue-floating-interactions").InteractionDelay>;
    readonly focusDelay: PropType<import("@visoning/vue-floating-interactions").InteractionDelay>;
    readonly allowPointerEnterTarget: BooleanConstructor;
    readonly inactiveWhenClickOutside: BooleanConstructor;
    readonly 'onUpdate:active': PropType<(active: boolean, info?: BaseInteractionInfo<string, Event>) => void>;
    readonly onActive: PropType<(info?: BaseInteractionInfo<string, Event>) => void>;
    readonly onInactive: PropType<(info?: BaseInteractionInfo<string, Event>) => void>;
}, {
    readonly active: false;
    readonly interactions: "hover";
    readonly inactiveWhenClickOutside: true;
    readonly allowPointerEnterTarget: true;
}>, "active" | "delay" | "interactions" | "customInteractions" | "targets" | "hoverDelay" | "clickDelay" | "focusDelay" | "allowPointerEnterTarget" | "inactiveWhenClickOutside" | "onUpdate:active" | "onActive" | "onInactive">;
export declare const PopupPropsType: {
    /**
     * Whether to open popup.
     */
    readonly open: BooleanConstructor;
    /**
     * Default state of open, typically used in uncontrolled mode.
     *
     * @default false
     */
    readonly defaultOpen: BooleanConstructor;
    /**
     * Whether to disable the floating.
     */
    readonly disabled: BooleanConstructor;
    /**
     * You can position a floating element relative to a virtual element instead of a real one.
     * This enables things like positioning context menus or following the cursor.
     * @see https://floating-ui.com/docs/virtual-elements
     */
    readonly virtualElement: PropType<VirtualElement>;
    /**
     * When this value is `true`, popup will be teleport to the target.
     * The teleport to target must be already in the DOM when the <Teleport> component is mounted.
     * @see https://vuejs.org/guide/built-ins/teleport.html
     *
     * Or you can customize the teleport logic, set `appendTo` to false, and use `floatingWrapper`,
     * for simple example
     * @example
     * ```ts
     * {
     *   appendTo: false,
     *   floatingWrapper: (floating) => h(
     *    Teleport,
     *    {
     *      to: anyTarget
     *    },
     *    {
     *      default: () => [floating]
     *    }
     *   )
     * }
     * ```
     *
     * @default 'body'
     */
    readonly appendTo: PropType<string | false | HTMLElement>;
    /**
     * When this value is `false`, even if the popup is closed, floating will update the position as needed,
     * unless popup is disabled.
     */
    readonly autoUpdateOnClosed: BooleanConstructor;
    /**
     * Displaces the popup element from its core placement along the specified axes.
     * @see https://floating-ui.com/docs/offset
     */
    readonly offset: PropType<OffsetOptions>;
    /**
     * Moves the popup element along the specified axes in order to keep it in view.
     * @see https://floating-ui.com/docs/shift
     *
     * @default true
     */
    readonly shift: PropType<boolean | ShiftOptions>;
    /**
     * Changes the placement of the popup element to the opposite one by default in order to keep it in view.
     * @see https://floating-ui.com/docs/flip
     */
    readonly flip: PropType<boolean | FlipOptions>;
    /**
     * Chooses the placement that has the most space available automatically.
     *
     * You’ll want to use this instead of `flip` if you don't want to give the popup element a “preferred” placement
     * and let it choose a placement for you.
     * @see https://floating-ui.com/docs/autoPlacement
     */
    readonly autoPlacement: PropType<boolean | AutoPlacementOptions>;
    /**
     * This determines whether GPU-accelerated styles are used to position the popup.
     * When this value is `true`, popup will use the 3D transforms.
     * When this value is `false`, popup will use top/left properties.
     */
    readonly gpuAcceleration: BooleanConstructor;
    /**
     * Whether destroy popup when closed.
     */
    readonly destoryedOnClosed: BooleanConstructor;
    /**
     * HTML attributes of node.
     */
    readonly floatingProps: PropType<Record<string, any>>;
    /**
     * Custom floating node wrapper.
     * The basic DOM structure is `<Floating/> -> <Popup/> -> <PopupContent/>`.
     */
    readonly floatingWrapper: PropType<(popup: VNode | null) => VNode>;
    /**
     * HTML attributes of node.
     */
    readonly popupProps: PropType<Record<string, any>>;
    /**
     * Custom popup node wrapper.
     * The basic DOM structure is `<Floating/> -> <Popup/> -> <PopupContent/>`.
     */
    readonly popupWrapper: PropType<(popup: VNode | null) => VNode>;
    /**
     * Popup z-index.
     */
    readonly zIndex: NumberConstructor;
    /**
     * Callback on open status changes.
     */
    readonly 'onUpdate:open': PropType<(open: boolean, info: BaseInteractionInfo) => void>;
    /**
     * Callback on popup open.
     */
    readonly onOpen: PropType<(info: BaseInteractionInfo) => void>;
    /**
     * Callback on popup close.
     */
    readonly onClose: PropType<(info: BaseInteractionInfo) => void>;
    readonly active: Omit<{
        type: BooleanConstructor;
    }, "default"> & {
        default: false;
    };
    readonly delay: PropType<import("@visoning/vue-floating-interactions").InteractionDelay>;
    readonly interactions: Omit<{
        type: new (...args: any[]) => (false | import("@visoning/vue-floating-interactions").Interaction | import("@visoning/vue-floating-interactions").Interaction[]) & {};
    } | {
        type: () => false | import("@visoning/vue-floating-interactions").Interaction | import("@visoning/vue-floating-interactions").Interaction[];
    } | {
        type: ((new (...args: any[]) => (false | import("@visoning/vue-floating-interactions").Interaction | import("@visoning/vue-floating-interactions").Interaction[]) & {}) | (() => false | import("@visoning/vue-floating-interactions").Interaction | import("@visoning/vue-floating-interactions").Interaction[]))[];
    }, "default"> & {
        default: "hover";
    };
    readonly customInteractions: PropType<((context: import("@visoning/vue-floating-interactions").InteractionsContext<string, Event>) => import("@visoning/vue-utility").MaybeRef<import("@visoning/vue-floating-interactions").ElementProps>)[]>;
    readonly targets: PropType<HTMLElement[]>;
    readonly hoverDelay: PropType<import("@visoning/vue-floating-interactions").InteractionDelay>;
    readonly clickDelay: PropType<import("@visoning/vue-floating-interactions").InteractionDelay>;
    readonly focusDelay: PropType<import("@visoning/vue-floating-interactions").InteractionDelay>;
    readonly allowPointerEnterTarget: Omit<{
        type: BooleanConstructor;
    }, "default"> & {
        default: true;
    };
    readonly inactiveWhenClickOutside: Omit<{
        type: BooleanConstructor;
    }, "default"> & {
        default: true;
    };
    readonly 'onUpdate:active': PropType<(active: boolean, info?: BaseInteractionInfo<string, Event>) => void>;
    readonly onActive: PropType<(info?: BaseInteractionInfo<string, Event>) => void>;
    readonly onInactive: PropType<(info?: BaseInteractionInfo<string, Event>) => void>;
    readonly onFloatingDataUpdate: PropType<(data: {
        x: number;
        y: number;
        strategy: import("@floating-ui/core").Strategy;
        placement: import("@floating-ui/core").Placement;
        middlewareData: {
            [x: string]: any;
            arrow?: {
                x?: number;
                y?: number;
                centerOffset: number;
            };
            autoPlacement?: {
                index?: number;
                overflows: {
                    placement: import("@floating-ui/core").Placement;
                    overflows: number[];
                }[];
            };
            flip?: {
                index?: number;
                overflows: {
                    placement: import("@floating-ui/core").Placement;
                    overflows: number[];
                }[];
            };
            hide?: {
                referenceHidden?: boolean;
                escaped?: boolean;
                referenceHiddenOffsets?: {
                    left: number;
                    top: number;
                    bottom: number;
                    right: number;
                };
                escapedOffsets?: {
                    left: number;
                    top: number;
                    bottom: number;
                    right: number;
                };
            };
            offset?: {
                x: number;
                y: number;
            };
            shift?: {
                x: number;
                y: number;
            };
        };
    }) => void>;
    readonly reference: {
        type: PropType<ReferenceType>;
    };
    readonly floating: {
        type: PropType<HTMLElement>;
    };
    readonly strategy: Omit<{
        type: new (...args: any[]) => import("@floating-ui/core").Strategy & {};
    } | {
        type: () => import("@floating-ui/core").Strategy;
    } | {
        type: ((new (...args: any[]) => import("@floating-ui/core").Strategy & {}) | (() => import("@floating-ui/core").Strategy))[];
    }, "default"> & {
        default: "absolute";
    };
    readonly middleware: PropType<import("@floating-ui/core").Middleware[]>;
    readonly placement: Omit<{
        type: new (...args: any[]) => import("@floating-ui/core").Placement & {};
    } | {
        type: () => import("@floating-ui/core").Placement;
    } | {
        type: ((new (...args: any[]) => import("@floating-ui/core").Placement & {}) | (() => import("@floating-ui/core").Placement))[];
    }, "default"> & {
        default: "bottom";
    };
    readonly autoUpdate: Omit<{
        type: new (...args: any[]) => (boolean | import("@visoning/vue-floating-core").UseAutoUpdateOptions) & {};
    } | {
        type: () => boolean | import("@visoning/vue-floating-core").UseAutoUpdateOptions;
    } | {
        type: ((new (...args: any[]) => (boolean | import("@visoning/vue-floating-core").UseAutoUpdateOptions) & {}) | (() => boolean | import("@visoning/vue-floating-core").UseAutoUpdateOptions))[];
    }, "default"> & {
        default: true;
    };
};
export declare const PopupDefaultProps: {
    readonly open: any;
    readonly defaultOpen: false;
    readonly shift: true;
    readonly appendTo: "viewport";
};
export declare const PopupProps: import("@visoning/vue-utility").WithDefaultProps<{
    /**
     * Whether to open popup.
     */
    readonly open: BooleanConstructor;
    /**
     * Default state of open, typically used in uncontrolled mode.
     *
     * @default false
     */
    readonly defaultOpen: BooleanConstructor;
    /**
     * Whether to disable the floating.
     */
    readonly disabled: BooleanConstructor;
    /**
     * You can position a floating element relative to a virtual element instead of a real one.
     * This enables things like positioning context menus or following the cursor.
     * @see https://floating-ui.com/docs/virtual-elements
     */
    readonly virtualElement: PropType<VirtualElement>;
    /**
     * When this value is `true`, popup will be teleport to the target.
     * The teleport to target must be already in the DOM when the <Teleport> component is mounted.
     * @see https://vuejs.org/guide/built-ins/teleport.html
     *
     * Or you can customize the teleport logic, set `appendTo` to false, and use `floatingWrapper`,
     * for simple example
     * @example
     * ```ts
     * {
     *   appendTo: false,
     *   floatingWrapper: (floating) => h(
     *    Teleport,
     *    {
     *      to: anyTarget
     *    },
     *    {
     *      default: () => [floating]
     *    }
     *   )
     * }
     * ```
     *
     * @default 'body'
     */
    readonly appendTo: PropType<string | false | HTMLElement>;
    /**
     * When this value is `false`, even if the popup is closed, floating will update the position as needed,
     * unless popup is disabled.
     */
    readonly autoUpdateOnClosed: BooleanConstructor;
    /**
     * Displaces the popup element from its core placement along the specified axes.
     * @see https://floating-ui.com/docs/offset
     */
    readonly offset: PropType<OffsetOptions>;
    /**
     * Moves the popup element along the specified axes in order to keep it in view.
     * @see https://floating-ui.com/docs/shift
     *
     * @default true
     */
    readonly shift: PropType<boolean | ShiftOptions>;
    /**
     * Changes the placement of the popup element to the opposite one by default in order to keep it in view.
     * @see https://floating-ui.com/docs/flip
     */
    readonly flip: PropType<boolean | FlipOptions>;
    /**
     * Chooses the placement that has the most space available automatically.
     *
     * You’ll want to use this instead of `flip` if you don't want to give the popup element a “preferred” placement
     * and let it choose a placement for you.
     * @see https://floating-ui.com/docs/autoPlacement
     */
    readonly autoPlacement: PropType<boolean | AutoPlacementOptions>;
    /**
     * This determines whether GPU-accelerated styles are used to position the popup.
     * When this value is `true`, popup will use the 3D transforms.
     * When this value is `false`, popup will use top/left properties.
     */
    readonly gpuAcceleration: BooleanConstructor;
    /**
     * Whether destroy popup when closed.
     */
    readonly destoryedOnClosed: BooleanConstructor;
    /**
     * HTML attributes of node.
     */
    readonly floatingProps: PropType<Record<string, any>>;
    /**
     * Custom floating node wrapper.
     * The basic DOM structure is `<Floating/> -> <Popup/> -> <PopupContent/>`.
     */
    readonly floatingWrapper: PropType<(popup: VNode | null) => VNode>;
    /**
     * HTML attributes of node.
     */
    readonly popupProps: PropType<Record<string, any>>;
    /**
     * Custom popup node wrapper.
     * The basic DOM structure is `<Floating/> -> <Popup/> -> <PopupContent/>`.
     */
    readonly popupWrapper: PropType<(popup: VNode | null) => VNode>;
    /**
     * Popup z-index.
     */
    readonly zIndex: NumberConstructor;
    /**
     * Callback on open status changes.
     */
    readonly 'onUpdate:open': PropType<(open: boolean, info: BaseInteractionInfo) => void>;
    /**
     * Callback on popup open.
     */
    readonly onOpen: PropType<(info: BaseInteractionInfo) => void>;
    /**
     * Callback on popup close.
     */
    readonly onClose: PropType<(info: BaseInteractionInfo) => void>;
    readonly active: Omit<{
        type: BooleanConstructor;
    }, "default"> & {
        default: false;
    };
    readonly delay: PropType<import("@visoning/vue-floating-interactions").InteractionDelay>;
    readonly interactions: Omit<{
        type: new (...args: any[]) => (false | import("@visoning/vue-floating-interactions").Interaction | import("@visoning/vue-floating-interactions").Interaction[]) & {};
    } | {
        type: () => false | import("@visoning/vue-floating-interactions").Interaction | import("@visoning/vue-floating-interactions").Interaction[];
    } | {
        type: ((new (...args: any[]) => (false | import("@visoning/vue-floating-interactions").Interaction | import("@visoning/vue-floating-interactions").Interaction[]) & {}) | (() => false | import("@visoning/vue-floating-interactions").Interaction | import("@visoning/vue-floating-interactions").Interaction[]))[];
    }, "default"> & {
        default: "hover";
    };
    readonly customInteractions: PropType<((context: import("@visoning/vue-floating-interactions").InteractionsContext<string, Event>) => import("@visoning/vue-utility").MaybeRef<import("@visoning/vue-floating-interactions").ElementProps>)[]>;
    readonly targets: PropType<HTMLElement[]>;
    readonly hoverDelay: PropType<import("@visoning/vue-floating-interactions").InteractionDelay>;
    readonly clickDelay: PropType<import("@visoning/vue-floating-interactions").InteractionDelay>;
    readonly focusDelay: PropType<import("@visoning/vue-floating-interactions").InteractionDelay>;
    readonly allowPointerEnterTarget: Omit<{
        type: BooleanConstructor;
    }, "default"> & {
        default: true;
    };
    readonly inactiveWhenClickOutside: Omit<{
        type: BooleanConstructor;
    }, "default"> & {
        default: true;
    };
    readonly 'onUpdate:active': PropType<(active: boolean, info?: BaseInteractionInfo<string, Event>) => void>;
    readonly onActive: PropType<(info?: BaseInteractionInfo<string, Event>) => void>;
    readonly onInactive: PropType<(info?: BaseInteractionInfo<string, Event>) => void>;
    readonly onFloatingDataUpdate: PropType<(data: {
        x: number;
        y: number;
        strategy: import("@floating-ui/core").Strategy;
        placement: import("@floating-ui/core").Placement;
        middlewareData: {
            [x: string]: any;
            arrow?: {
                x?: number;
                y?: number;
                centerOffset: number;
            };
            autoPlacement?: {
                index?: number;
                overflows: {
                    placement: import("@floating-ui/core").Placement;
                    overflows: number[];
                }[];
            };
            flip?: {
                index?: number;
                overflows: {
                    placement: import("@floating-ui/core").Placement;
                    overflows: number[];
                }[];
            };
            hide?: {
                referenceHidden?: boolean;
                escaped?: boolean;
                referenceHiddenOffsets?: {
                    left: number;
                    top: number;
                    bottom: number;
                    right: number;
                };
                escapedOffsets?: {
                    left: number;
                    top: number;
                    bottom: number;
                    right: number;
                };
            };
            offset?: {
                x: number;
                y: number;
            };
            shift?: {
                x: number;
                y: number;
            };
        };
    }) => void>;
    readonly reference: {
        type: PropType<ReferenceType>;
    };
    readonly floating: {
        type: PropType<HTMLElement>;
    };
    readonly strategy: Omit<{
        type: new (...args: any[]) => import("@floating-ui/core").Strategy & {};
    } | {
        type: () => import("@floating-ui/core").Strategy;
    } | {
        type: ((new (...args: any[]) => import("@floating-ui/core").Strategy & {}) | (() => import("@floating-ui/core").Strategy))[];
    }, "default"> & {
        default: "absolute";
    };
    readonly middleware: PropType<import("@floating-ui/core").Middleware[]>;
    readonly placement: Omit<{
        type: new (...args: any[]) => import("@floating-ui/core").Placement & {};
    } | {
        type: () => import("@floating-ui/core").Placement;
    } | {
        type: ((new (...args: any[]) => import("@floating-ui/core").Placement & {}) | (() => import("@floating-ui/core").Placement))[];
    }, "default"> & {
        default: "bottom";
    };
    readonly autoUpdate: Omit<{
        type: new (...args: any[]) => (boolean | import("@visoning/vue-floating-core").UseAutoUpdateOptions) & {};
    } | {
        type: () => boolean | import("@visoning/vue-floating-core").UseAutoUpdateOptions;
    } | {
        type: ((new (...args: any[]) => (boolean | import("@visoning/vue-floating-core").UseAutoUpdateOptions) & {}) | (() => boolean | import("@visoning/vue-floating-core").UseAutoUpdateOptions))[];
    }, "default"> & {
        default: true;
    };
}, {
    readonly open: any;
    readonly defaultOpen: false;
    readonly shift: true;
    readonly appendTo: "viewport";
}>;
export declare type PopupProps = ExtractPropTypes<typeof PopupProps>;
