export declare const classNames: {
    tooltip: string;
    content: string;
};
export declare const Tooltip: import("vue-demi").DefineComponent<import("@visoning/vue-utility").WithDefaultProps<{
    readonly textAlign: import("vue-demi").PropType<"center" | "end" | "start" | "left" | "right" | "justify" | "match-parent">;
    readonly tooltipProps: import("vue-demi").PropType<Record<string, any>>;
    readonly tooltipWrapper: import("vue-demi").PropType<(popup: import("vue-demi").VNode<import("vue-demi").RendererNode, import("vue-demi").RendererElement, {
        [key: string]: any;
    }>) => import("vue-demi").VNode<import("vue-demi").RendererNode, import("vue-demi").RendererElement, {
        [key: string]: any;
    }>>;
    readonly onFloatingDataUpdate: import("vue-demi").PropType<(data: {
        x: number;
        y: number;
        strategy: import("@floating-ui/core").Strategy;
        placement: import("@floating-ui/core").Placement;
        middlewareData: {
            [x: string]: any;
            arrow?: {
                x?: number;
                y?: number;
                centerOffset: number;
            };
            autoPlacement?: {
                index?: number;
                overflows: {
                    placement: import("@floating-ui/core").Placement;
                    overflows: number[];
                }[];
            };
            flip?: {
                index?: number;
                overflows: {
                    placement: import("@floating-ui/core").Placement;
                    overflows: number[];
                }[];
            };
            hide?: {
                referenceHidden?: boolean;
                escaped?: boolean;
                referenceHiddenOffsets?: {
                    left: number;
                    top: number;
                    bottom: number;
                    right: number;
                };
                escapedOffsets?: {
                    left: number;
                    top: number;
                    bottom: number;
                    right: number;
                };
            };
            offset?: {
                x: number;
                y: number;
            };
            shift?: {
                x: number;
                y: number;
            };
        };
    }) => void>;
    readonly 'onUpdate:open': import("vue-demi").PropType<(open: boolean, info: import("@visoning/vue-floating-interactions").BaseInteractionInfo<string, Event>) => void>;
    readonly onOpen: import("vue-demi").PropType<(info: import("@visoning/vue-floating-interactions").BaseInteractionInfo<string, Event>) => void>;
    readonly onClose: import("vue-demi").PropType<(info: import("@visoning/vue-floating-interactions").BaseInteractionInfo<string, Event>) => void>;
    readonly shift: Omit<{
        type: new (...args: any[]) => (boolean | import("@floating-ui/core").ShiftOptions) & {};
    } | {
        type: () => boolean | import("@floating-ui/core").ShiftOptions;
    } | {
        type: ((new (...args: any[]) => (boolean | import("@floating-ui/core").ShiftOptions) & {}) | (() => boolean | import("@floating-ui/core").ShiftOptions))[];
    }, "default"> & {
        default: true;
    };
    readonly offset: import("vue-demi").PropType<import("@floating-ui/core").OffsetOptions>;
    readonly active: Omit<{
        type: BooleanConstructor;
    }, "default"> & {
        default: false;
    };
    readonly open: BooleanConstructor;
    readonly content: import("vue-demi").PropType<string | (() => import("vue-demi").VNode<import("vue-demi").RendererNode, import("vue-demi").RendererElement, {
        [key: string]: any;
    }>)>;
    readonly zIndex: NumberConstructor;
    readonly title: import("vue-demi").PropType<string | (() => import("vue-demi").VNode<import("vue-demi").RendererNode, import("vue-demi").RendererElement, {
        [key: string]: any;
    }>)>;
    readonly disabled: BooleanConstructor;
    readonly size: Omit<{
        type: new (...args: any[]) => ("small" | "meduim") & {};
    } | {
        type: () => "small" | "meduim";
    } | {
        type: ((new (...args: any[]) => ("small" | "meduim") & {}) | (() => "small" | "meduim"))[];
    }, "default"> & {
        default: "meduim";
    };
    readonly reference: {
        type: import("vue-demi").PropType<import("@visoning/vue-floating-core").ReferenceType>;
    };
    readonly floating: {
        type: import("vue-demi").PropType<HTMLElement>;
    };
    readonly strategy: Omit<{
        type: new (...args: any[]) => import("@floating-ui/core").Strategy & {};
    } | {
        type: () => import("@floating-ui/core").Strategy;
    } | {
        type: ((new (...args: any[]) => import("@floating-ui/core").Strategy & {}) | (() => import("@floating-ui/core").Strategy))[];
    }, "default"> & {
        default: "absolute";
    };
    readonly arrow: import("vue-demi").PropType<import("../popover").CreateArrow>;
    readonly autoPlacement: import("vue-demi").PropType<boolean | import("@floating-ui/core").AutoPlacementOptions>;
    readonly flip: import("vue-demi").PropType<boolean | import("@floating-ui/core").FlipOptions>;
    readonly middleware: import("vue-demi").PropType<import("@floating-ui/core").Middleware[]>;
    readonly placement: Omit<{
        type: new (...args: any[]) => import("@floating-ui/core").Placement & {};
    } | {
        type: () => import("@floating-ui/core").Placement;
    } | {
        type: ((new (...args: any[]) => import("@floating-ui/core").Placement & {}) | (() => import("@floating-ui/core").Placement))[];
    }, "default"> & {
        default: "bottom";
    };
    readonly autoUpdate: Omit<{
        type: new (...args: any[]) => (boolean | import("@visoning/vue-floating-core").UseAutoUpdateOptions) & {};
    } | {
        type: () => boolean | import("@visoning/vue-floating-core").UseAutoUpdateOptions;
    } | {
        type: ((new (...args: any[]) => (boolean | import("@visoning/vue-floating-core").UseAutoUpdateOptions) & {}) | (() => boolean | import("@visoning/vue-floating-core").UseAutoUpdateOptions))[];
    }, "default"> & {
        default: true;
    };
    readonly delay: import("vue-demi").PropType<import("@visoning/vue-floating-interactions").InteractionDelay>;
    readonly interactions: Omit<{
        type: new (...args: any[]) => (false | import("@visoning/vue-floating-interactions").Interaction | import("@visoning/vue-floating-interactions").Interaction[]) & {};
    } | {
        type: () => false | import("@visoning/vue-floating-interactions").Interaction | import("@visoning/vue-floating-interactions").Interaction[];
    } | {
        type: ((new (...args: any[]) => (false | import("@visoning/vue-floating-interactions").Interaction | import("@visoning/vue-floating-interactions").Interaction[]) & {}) | (() => false | import("@visoning/vue-floating-interactions").Interaction | import("@visoning/vue-floating-interactions").Interaction[]))[];
    }, "default"> & {
        default: "hover";
    };
    readonly customInteractions: import("vue-demi").PropType<((context: import("@visoning/vue-floating-interactions").InteractionsContext<string, Event>) => import("@visoning/vue-utility").MaybeRef<import("@visoning/vue-floating-interactions").ElementProps>)[]>;
    readonly targets: import("vue-demi").PropType<HTMLElement[]>;
    readonly hoverDelay: import("vue-demi").PropType<import("@visoning/vue-floating-interactions").InteractionDelay>;
    readonly clickDelay: import("vue-demi").PropType<import("@visoning/vue-floating-interactions").InteractionDelay>;
    readonly focusDelay: import("vue-demi").PropType<import("@visoning/vue-floating-interactions").InteractionDelay>;
    readonly allowPointerEnterTarget: Omit<{
        type: BooleanConstructor;
    }, "default"> & {
        default: true;
    };
    readonly inactiveWhenClickOutside: Omit<{
        type: BooleanConstructor;
    }, "default"> & {
        default: true;
    };
    readonly 'onUpdate:active': import("vue-demi").PropType<(active: boolean, info?: import("@visoning/vue-floating-interactions").BaseInteractionInfo<string, Event>) => void>;
    readonly onActive: import("vue-demi").PropType<(info?: import("@visoning/vue-floating-interactions").BaseInteractionInfo<string, Event>) => void>;
    readonly onInactive: import("vue-demi").PropType<(info?: import("@visoning/vue-floating-interactions").BaseInteractionInfo<string, Event>) => void>;
    readonly defaultOpen: Omit<{
        type: BooleanConstructor;
    }, "default"> & {
        default: false;
    };
    readonly virtualElement: import("vue-demi").PropType<import("@floating-ui/dom").VirtualElement>;
    readonly appendTo: Omit<{
        type: new (...args: any[]) => (string | false | HTMLElement) & {};
    } | {
        type: () => string | false | HTMLElement;
    } | {
        type: ((new (...args: any[]) => (string | false | HTMLElement) & {}) | (() => string | false | HTMLElement))[];
    }, "default"> & {
        default: "viewport";
    };
    readonly autoUpdateOnClosed: BooleanConstructor;
    readonly gpuAcceleration: BooleanConstructor;
    readonly destoryedOnClosed: BooleanConstructor;
    readonly floatingProps: import("vue-demi").PropType<Record<string, any>>;
    readonly floatingWrapper: import("vue-demi").PropType<(popup: import("vue-demi").VNode<import("vue-demi").RendererNode, import("vue-demi").RendererElement, {
        [key: string]: any;
    }>) => import("vue-demi").VNode<import("vue-demi").RendererNode, import("vue-demi").RendererElement, {
        [key: string]: any;
    }>>;
    readonly popupProps: import("vue-demi").PropType<Record<string, any>>;
    readonly popupWrapper: import("vue-demi").PropType<(popup: import("vue-demi").VNode<import("vue-demi").RendererNode, import("vue-demi").RendererElement, {
        [key: string]: any;
    }>) => import("vue-demi").VNode<import("vue-demi").RendererNode, import("vue-demi").RendererElement, {
        [key: string]: any;
    }>>;
    readonly theme: Omit<{
        type: new (...args: any[]) => ("dark" | "light") & {};
    } | {
        type: () => "dark" | "light";
    } | {
        type: ((new (...args: any[]) => ("dark" | "light") & {}) | (() => "dark" | "light"))[];
    }, "default"> & {
        default: "line";
    };
    readonly transitionProps: Omit<{
        type: new (...args: any[]) => (string | Record<string, any>) & {};
    } | {
        type: () => string | Record<string, any>;
    } | {
        type: ((new (...args: any[]) => (string | Record<string, any>) & {}) | (() => string | Record<string, any>))[];
    }, "default"> & {
        default: "visoning-popover";
    };
    readonly showArrow: Omit<{
        type: BooleanConstructor;
    }, "default"> & {
        default: true;
    };
    readonly arrowProps: import("vue-demi").PropType<Record<string, any>>;
    readonly popoverProps: import("vue-demi").PropType<Record<string, any>>;
    readonly contentProps: import("vue-demi").PropType<Record<string, any>>;
    readonly popoverWrapper: import("vue-demi").PropType<(popup: import("vue-demi").VNode<import("vue-demi").RendererNode, import("vue-demi").RendererElement, {
        [key: string]: any;
    }>) => import("vue-demi").VNode<import("vue-demi").RendererNode, import("vue-demi").RendererElement, {
        [key: string]: any;
    }>>;
}, {
    readonly interactions: "hover";
    readonly theme: "drak";
    readonly textAlign: "start";
}>, () => import("vue-demi").VNode<import("vue-demi").RendererNode, import("vue-demi").RendererElement, {
    [key: string]: any;
}>, unknown, {}, {}, import("vue-demi").ComponentOptionsMixin, import("vue-demi").ComponentOptionsMixin, {}, string, import("vue-demi").VNodeProps & import("vue-demi").AllowedComponentProps & import("vue-demi").ComponentCustomProps, Readonly<import("vue-demi").ExtractPropTypes<import("@visoning/vue-utility").WithDefaultProps<{
    readonly textAlign: import("vue-demi").PropType<"center" | "end" | "start" | "left" | "right" | "justify" | "match-parent">;
    readonly tooltipProps: import("vue-demi").PropType<Record<string, any>>;
    readonly tooltipWrapper: import("vue-demi").PropType<(popup: import("vue-demi").VNode<import("vue-demi").RendererNode, import("vue-demi").RendererElement, {
        [key: string]: any;
    }>) => import("vue-demi").VNode<import("vue-demi").RendererNode, import("vue-demi").RendererElement, {
        [key: string]: any;
    }>>;
    readonly onFloatingDataUpdate: import("vue-demi").PropType<(data: {
        x: number;
        y: number;
        strategy: import("@floating-ui/core").Strategy;
        placement: import("@floating-ui/core").Placement;
        middlewareData: {
            [x: string]: any;
            arrow?: {
                x?: number;
                y?: number;
                centerOffset: number;
            };
            autoPlacement?: {
                index?: number;
                overflows: {
                    placement: import("@floating-ui/core").Placement;
                    overflows: number[];
                }[];
            };
            flip?: {
                index?: number;
                overflows: {
                    placement: import("@floating-ui/core").Placement;
                    overflows: number[];
                }[];
            };
            hide?: {
                referenceHidden?: boolean;
                escaped?: boolean;
                referenceHiddenOffsets?: {
                    left: number;
                    top: number;
                    bottom: number;
                    right: number;
                };
                escapedOffsets?: {
                    left: number;
                    top: number;
                    bottom: number;
                    right: number;
                };
            };
            offset?: {
                x: number;
                y: number;
            };
            shift?: {
                x: number;
                y: number;
            };
        };
    }) => void>;
    readonly 'onUpdate:open': import("vue-demi").PropType<(open: boolean, info: import("@visoning/vue-floating-interactions").BaseInteractionInfo<string, Event>) => void>;
    readonly onOpen: import("vue-demi").PropType<(info: import("@visoning/vue-floating-interactions").BaseInteractionInfo<string, Event>) => void>;
    readonly onClose: import("vue-demi").PropType<(info: import("@visoning/vue-floating-interactions").BaseInteractionInfo<string, Event>) => void>;
    readonly shift: Omit<{
        type: new (...args: any[]) => (boolean | import("@floating-ui/core").ShiftOptions) & {};
    } | {
        type: () => boolean | import("@floating-ui/core").ShiftOptions;
    } | {
        type: ((new (...args: any[]) => (boolean | import("@floating-ui/core").ShiftOptions) & {}) | (() => boolean | import("@floating-ui/core").ShiftOptions))[];
    }, "default"> & {
        default: true;
    };
    readonly offset: import("vue-demi").PropType<import("@floating-ui/core").OffsetOptions>;
    readonly active: Omit<{
        type: BooleanConstructor;
    }, "default"> & {
        default: false;
    };
    readonly open: BooleanConstructor;
    readonly content: import("vue-demi").PropType<string | (() => import("vue-demi").VNode<import("vue-demi").RendererNode, import("vue-demi").RendererElement, {
        [key: string]: any;
    }>)>;
    readonly zIndex: NumberConstructor;
    readonly title: import("vue-demi").PropType<string | (() => import("vue-demi").VNode<import("vue-demi").RendererNode, import("vue-demi").RendererElement, {
        [key: string]: any;
    }>)>;
    readonly disabled: BooleanConstructor;
    readonly size: Omit<{
        type: new (...args: any[]) => ("small" | "meduim") & {};
    } | {
        type: () => "small" | "meduim";
    } | {
        type: ((new (...args: any[]) => ("small" | "meduim") & {}) | (() => "small" | "meduim"))[];
    }, "default"> & {
        default: "meduim";
    };
    readonly reference: {
        type: import("vue-demi").PropType<import("@visoning/vue-floating-core").ReferenceType>;
    };
    readonly floating: {
        type: import("vue-demi").PropType<HTMLElement>;
    };
    readonly strategy: Omit<{
        type: new (...args: any[]) => import("@floating-ui/core").Strategy & {};
    } | {
        type: () => import("@floating-ui/core").Strategy;
    } | {
        type: ((new (...args: any[]) => import("@floating-ui/core").Strategy & {}) | (() => import("@floating-ui/core").Strategy))[];
    }, "default"> & {
        default: "absolute";
    };
    readonly arrow: import("vue-demi").PropType<import("../popover").CreateArrow>;
    readonly autoPlacement: import("vue-demi").PropType<boolean | import("@floating-ui/core").AutoPlacementOptions>;
    readonly flip: import("vue-demi").PropType<boolean | import("@floating-ui/core").FlipOptions>;
    readonly middleware: import("vue-demi").PropType<import("@floating-ui/core").Middleware[]>;
    readonly placement: Omit<{
        type: new (...args: any[]) => import("@floating-ui/core").Placement & {};
    } | {
        type: () => import("@floating-ui/core").Placement;
    } | {
        type: ((new (...args: any[]) => import("@floating-ui/core").Placement & {}) | (() => import("@floating-ui/core").Placement))[];
    }, "default"> & {
        default: "bottom";
    };
    readonly autoUpdate: Omit<{
        type: new (...args: any[]) => (boolean | import("@visoning/vue-floating-core").UseAutoUpdateOptions) & {};
    } | {
        type: () => boolean | import("@visoning/vue-floating-core").UseAutoUpdateOptions;
    } | {
        type: ((new (...args: any[]) => (boolean | import("@visoning/vue-floating-core").UseAutoUpdateOptions) & {}) | (() => boolean | import("@visoning/vue-floating-core").UseAutoUpdateOptions))[];
    }, "default"> & {
        default: true;
    };
    readonly delay: import("vue-demi").PropType<import("@visoning/vue-floating-interactions").InteractionDelay>;
    readonly interactions: Omit<{
        type: new (...args: any[]) => (false | import("@visoning/vue-floating-interactions").Interaction | import("@visoning/vue-floating-interactions").Interaction[]) & {};
    } | {
        type: () => false | import("@visoning/vue-floating-interactions").Interaction | import("@visoning/vue-floating-interactions").Interaction[];
    } | {
        type: ((new (...args: any[]) => (false | import("@visoning/vue-floating-interactions").Interaction | import("@visoning/vue-floating-interactions").Interaction[]) & {}) | (() => false | import("@visoning/vue-floating-interactions").Interaction | import("@visoning/vue-floating-interactions").Interaction[]))[];
    }, "default"> & {
        default: "hover";
    };
    readonly customInteractions: import("vue-demi").PropType<((context: import("@visoning/vue-floating-interactions").InteractionsContext<string, Event>) => import("@visoning/vue-utility").MaybeRef<import("@visoning/vue-floating-interactions").ElementProps>)[]>;
    readonly targets: import("vue-demi").PropType<HTMLElement[]>;
    readonly hoverDelay: import("vue-demi").PropType<import("@visoning/vue-floating-interactions").InteractionDelay>;
    readonly clickDelay: import("vue-demi").PropType<import("@visoning/vue-floating-interactions").InteractionDelay>;
    readonly focusDelay: import("vue-demi").PropType<import("@visoning/vue-floating-interactions").InteractionDelay>;
    readonly allowPointerEnterTarget: Omit<{
        type: BooleanConstructor;
    }, "default"> & {
        default: true;
    };
    readonly inactiveWhenClickOutside: Omit<{
        type: BooleanConstructor;
    }, "default"> & {
        default: true;
    };
    readonly 'onUpdate:active': import("vue-demi").PropType<(active: boolean, info?: import("@visoning/vue-floating-interactions").BaseInteractionInfo<string, Event>) => void>;
    readonly onActive: import("vue-demi").PropType<(info?: import("@visoning/vue-floating-interactions").BaseInteractionInfo<string, Event>) => void>;
    readonly onInactive: import("vue-demi").PropType<(info?: import("@visoning/vue-floating-interactions").BaseInteractionInfo<string, Event>) => void>;
    readonly defaultOpen: Omit<{
        type: BooleanConstructor;
    }, "default"> & {
        default: false;
    };
    readonly virtualElement: import("vue-demi").PropType<import("@floating-ui/dom").VirtualElement>;
    readonly appendTo: Omit<{
        type: new (...args: any[]) => (string | false | HTMLElement) & {};
    } | {
        type: () => string | false | HTMLElement;
    } | {
        type: ((new (...args: any[]) => (string | false | HTMLElement) & {}) | (() => string | false | HTMLElement))[];
    }, "default"> & {
        default: "viewport";
    };
    readonly autoUpdateOnClosed: BooleanConstructor;
    readonly gpuAcceleration: BooleanConstructor;
    readonly destoryedOnClosed: BooleanConstructor;
    readonly floatingProps: import("vue-demi").PropType<Record<string, any>>;
    readonly floatingWrapper: import("vue-demi").PropType<(popup: import("vue-demi").VNode<import("vue-demi").RendererNode, import("vue-demi").RendererElement, {
        [key: string]: any;
    }>) => import("vue-demi").VNode<import("vue-demi").RendererNode, import("vue-demi").RendererElement, {
        [key: string]: any;
    }>>;
    readonly popupProps: import("vue-demi").PropType<Record<string, any>>;
    readonly popupWrapper: import("vue-demi").PropType<(popup: import("vue-demi").VNode<import("vue-demi").RendererNode, import("vue-demi").RendererElement, {
        [key: string]: any;
    }>) => import("vue-demi").VNode<import("vue-demi").RendererNode, import("vue-demi").RendererElement, {
        [key: string]: any;
    }>>;
    readonly theme: Omit<{
        type: new (...args: any[]) => ("dark" | "light") & {};
    } | {
        type: () => "dark" | "light";
    } | {
        type: ((new (...args: any[]) => ("dark" | "light") & {}) | (() => "dark" | "light"))[];
    }, "default"> & {
        default: "line";
    };
    readonly transitionProps: Omit<{
        type: new (...args: any[]) => (string | Record<string, any>) & {};
    } | {
        type: () => string | Record<string, any>;
    } | {
        type: ((new (...args: any[]) => (string | Record<string, any>) & {}) | (() => string | Record<string, any>))[];
    }, "default"> & {
        default: "visoning-popover";
    };
    readonly showArrow: Omit<{
        type: BooleanConstructor;
    }, "default"> & {
        default: true;
    };
    readonly arrowProps: import("vue-demi").PropType<Record<string, any>>;
    readonly popoverProps: import("vue-demi").PropType<Record<string, any>>;
    readonly contentProps: import("vue-demi").PropType<Record<string, any>>;
    readonly popoverWrapper: import("vue-demi").PropType<(popup: import("vue-demi").VNode<import("vue-demi").RendererNode, import("vue-demi").RendererElement, {
        [key: string]: any;
    }>) => import("vue-demi").VNode<import("vue-demi").RendererNode, import("vue-demi").RendererElement, {
        [key: string]: any;
    }>>;
}, {
    readonly interactions: "hover";
    readonly theme: "drak";
    readonly textAlign: "start";
}>>>, {
    readonly shift: boolean | import("@floating-ui/core").ShiftOptions;
    readonly active: boolean;
    readonly open: boolean;
    readonly textAlign: "center" | "end" | "start" | "left" | "right" | "justify" | "match-parent";
    readonly disabled: boolean;
    readonly size: "small" | "meduim";
    readonly strategy: import("@floating-ui/core").Strategy;
    readonly placement: import("@floating-ui/core").Placement;
    readonly autoUpdate: true;
    readonly interactions: false | import("@visoning/vue-floating-interactions").Interaction | import("@visoning/vue-floating-interactions").Interaction[];
    readonly allowPointerEnterTarget: boolean;
    readonly inactiveWhenClickOutside: boolean;
    readonly defaultOpen: boolean;
    readonly appendTo: string | false | HTMLElement;
    readonly autoUpdateOnClosed: boolean;
    readonly gpuAcceleration: boolean;
    readonly destoryedOnClosed: boolean;
    readonly theme: "dark" | "light";
    readonly transitionProps: "visoning-popover";
    readonly showArrow: boolean;
}>;
