import type { ExtractPropTypes, PropType, VNode } from 'vue-demi';
import type { FloatingData } from '@visoning/vue-floating-core';
import type { PopoverExposed } from '../popover';
export interface TooltipExposed extends PopoverExposed {
}
export declare type TooltipArrowSlotProps = FloatingData;
export declare const PopoverListenerForwarder: import("@visoning/vue-utility").UseListenerForwardReturn<import("@visoning/vue-utility").WithDefaultProps<{
    readonly title: PropType<string | (() => VNode<import("vue-demi").RendererNode, import("vue-demi").RendererElement, {
        [key: string]: any;
    }>)>;
    readonly content: PropType<string | (() => VNode<import("vue-demi").RendererNode, import("vue-demi").RendererElement, {
        [key: string]: any;
    }>)>;
    readonly theme: PropType<"dark" | "light">;
    readonly size: PropType<"small" | "meduim">;
    readonly transitionProps: PropType<string | Record<string, any>>;
    readonly showArrow: BooleanConstructor;
    readonly arrow: PropType<import("../popover").CreateArrow>;
    readonly arrowProps: PropType<Record<string, any>>;
    readonly popoverProps: PropType<Record<string, any>>;
    readonly contentProps: PropType<Record<string, any>>;
    readonly popoverWrapper: PropType<(popup: VNode<import("vue-demi").RendererNode, import("vue-demi").RendererElement, {
        [key: string]: any;
    }>) => VNode<import("vue-demi").RendererNode, import("vue-demi").RendererElement, {
        [key: string]: any;
    }>>;
    readonly onFloatingDataUpdate: PropType<(data: {
        x: number;
        y: number;
        strategy: import("@visoning/vue-floating-core").Strategy;
        placement: import("@visoning/vue-floating-core").Placement;
        middlewareData: {
            [x: string]: any;
            arrow?: {
                x?: number;
                y?: number;
                centerOffset: number;
            };
            autoPlacement?: {
                index?: number;
                overflows: {
                    placement: import("@visoning/vue-floating-core").Placement;
                    overflows: number[];
                }[];
            };
            flip?: {
                index?: number;
                overflows: {
                    placement: import("@visoning/vue-floating-core").Placement;
                    overflows: number[];
                }[];
            };
            hide?: {
                referenceHidden?: boolean;
                escaped?: boolean;
                referenceHiddenOffsets?: {
                    left: number;
                    top: number;
                    bottom: number;
                    right: number;
                };
                escapedOffsets?: {
                    left: number;
                    top: number;
                    bottom: number;
                    right: number;
                };
            };
            offset?: {
                x: number;
                y: number;
            };
            shift?: {
                x: number;
                y: number;
            };
        };
    }) => void>;
    readonly 'onUpdate:open': PropType<(open: boolean, info: import("@visoning/vue-floating-interactions").BaseInteractionInfo<string, Event>) => void>;
    readonly onOpen: PropType<(info: import("@visoning/vue-floating-interactions").BaseInteractionInfo<string, Event>) => void>;
    readonly onClose: PropType<(info: import("@visoning/vue-floating-interactions").BaseInteractionInfo<string, Event>) => void>;
    readonly shift: Omit<{
        type: new (...args: any[]) => (boolean | import("@floating-ui/core").ShiftOptions) & {};
    } | {
        type: () => boolean | import("@floating-ui/core").ShiftOptions;
    } | {
        type: ((new (...args: any[]) => (boolean | import("@floating-ui/core").ShiftOptions) & {}) | (() => boolean | import("@floating-ui/core").ShiftOptions))[];
    }, "default"> & {
        default: true;
    };
    readonly offset: PropType<import("@floating-ui/core").OffsetOptions>;
    readonly active: Omit<{
        type: BooleanConstructor;
    }, "default"> & {
        default: false;
    };
    readonly open: BooleanConstructor;
    readonly zIndex: NumberConstructor;
    readonly disabled: BooleanConstructor;
    readonly reference: {
        type: PropType<import("@visoning/vue-floating-core").ReferenceType>;
    };
    readonly floating: {
        type: PropType<HTMLElement>;
    };
    readonly strategy: Omit<{
        type: new (...args: any[]) => import("@visoning/vue-floating-core").Strategy & {};
    } | {
        type: () => import("@visoning/vue-floating-core").Strategy;
    } | {
        type: ((new (...args: any[]) => import("@visoning/vue-floating-core").Strategy & {}) | (() => import("@visoning/vue-floating-core").Strategy))[];
    }, "default"> & {
        default: "absolute";
    };
    readonly autoPlacement: PropType<boolean | import("@floating-ui/core").AutoPlacementOptions>;
    readonly flip: PropType<boolean | import("@floating-ui/core").FlipOptions>;
    readonly middleware: PropType<import("@visoning/vue-floating-core").Middleware[]>;
    readonly placement: Omit<{
        type: new (...args: any[]) => import("@visoning/vue-floating-core").Placement & {};
    } | {
        type: () => import("@visoning/vue-floating-core").Placement;
    } | {
        type: ((new (...args: any[]) => import("@visoning/vue-floating-core").Placement & {}) | (() => import("@visoning/vue-floating-core").Placement))[];
    }, "default"> & {
        default: "bottom";
    };
    readonly autoUpdate: Omit<{
        type: new (...args: any[]) => (boolean | import("@visoning/vue-floating-core").UseAutoUpdateOptions) & {};
    } | {
        type: () => boolean | import("@visoning/vue-floating-core").UseAutoUpdateOptions;
    } | {
        type: ((new (...args: any[]) => (boolean | import("@visoning/vue-floating-core").UseAutoUpdateOptions) & {}) | (() => boolean | import("@visoning/vue-floating-core").UseAutoUpdateOptions))[];
    }, "default"> & {
        default: true;
    };
    readonly delay: PropType<import("@visoning/vue-floating-interactions").InteractionDelay>;
    readonly interactions: Omit<{
        type: new (...args: any[]) => (false | import("@visoning/vue-floating-interactions").Interaction | import("@visoning/vue-floating-interactions").Interaction[]) & {};
    } | {
        type: () => false | import("@visoning/vue-floating-interactions").Interaction | import("@visoning/vue-floating-interactions").Interaction[];
    } | {
        type: ((new (...args: any[]) => (false | import("@visoning/vue-floating-interactions").Interaction | import("@visoning/vue-floating-interactions").Interaction[]) & {}) | (() => false | import("@visoning/vue-floating-interactions").Interaction | import("@visoning/vue-floating-interactions").Interaction[]))[];
    }, "default"> & {
        default: "hover";
    };
    readonly customInteractions: PropType<((context: import("@visoning/vue-floating-interactions").InteractionsContext<string, Event>) => import("@visoning/vue-utility").MaybeRef<import("@visoning/vue-floating-interactions").ElementProps>)[]>;
    readonly targets: PropType<HTMLElement[]>;
    readonly hoverDelay: PropType<import("@visoning/vue-floating-interactions").InteractionDelay>;
    readonly clickDelay: PropType<import("@visoning/vue-floating-interactions").InteractionDelay>;
    readonly focusDelay: PropType<import("@visoning/vue-floating-interactions").InteractionDelay>;
    readonly allowPointerEnterTarget: Omit<{
        type: BooleanConstructor;
    }, "default"> & {
        default: true;
    };
    readonly inactiveWhenClickOutside: Omit<{
        type: BooleanConstructor;
    }, "default"> & {
        default: true;
    };
    readonly 'onUpdate:active': PropType<(active: boolean, info?: import("@visoning/vue-floating-interactions").BaseInteractionInfo<string, Event>) => void>;
    readonly onActive: PropType<(info?: import("@visoning/vue-floating-interactions").BaseInteractionInfo<string, Event>) => void>;
    readonly onInactive: PropType<(info?: import("@visoning/vue-floating-interactions").BaseInteractionInfo<string, Event>) => void>;
    readonly defaultOpen: Omit<{
        type: BooleanConstructor;
    }, "default"> & {
        default: false;
    };
    readonly virtualElement: PropType<import("@visoning/vue-floating-core").VirtualElement>;
    readonly appendTo: Omit<{
        type: new (...args: any[]) => (string | false | HTMLElement) & {};
    } | {
        type: () => string | false | HTMLElement;
    } | {
        type: ((new (...args: any[]) => (string | false | HTMLElement) & {}) | (() => string | false | HTMLElement))[];
    }, "default"> & {
        default: "viewport";
    };
    readonly autoUpdateOnClosed: BooleanConstructor;
    readonly gpuAcceleration: BooleanConstructor;
    readonly destoryedOnClosed: BooleanConstructor;
    readonly floatingProps: PropType<Record<string, any>>;
    readonly floatingWrapper: PropType<(popup: VNode<import("vue-demi").RendererNode, import("vue-demi").RendererElement, {
        [key: string]: any;
    }>) => VNode<import("vue-demi").RendererNode, import("vue-demi").RendererElement, {
        [key: string]: any;
    }>>;
    readonly popupProps: PropType<Record<string, any>>;
    readonly popupWrapper: PropType<(popup: VNode<import("vue-demi").RendererNode, import("vue-demi").RendererElement, {
        [key: string]: any;
    }>) => VNode<import("vue-demi").RendererNode, import("vue-demi").RendererElement, {
        [key: string]: any;
    }>>;
}, {
    readonly theme: "line";
    readonly size: "meduim";
    readonly transitionProps: "visoning-popover";
    readonly showArrow: true;
}>, "onFloatingDataUpdate" | "onUpdate:open" | "onOpen" | "onClose">;
export declare const ExtendsPopoverProps: Pick<import("@visoning/vue-utility").WithDefaultProps<{
    readonly title: PropType<string | (() => VNode<import("vue-demi").RendererNode, import("vue-demi").RendererElement, {
        [key: string]: any;
    }>)>;
    readonly content: PropType<string | (() => VNode<import("vue-demi").RendererNode, import("vue-demi").RendererElement, {
        [key: string]: any;
    }>)>;
    readonly theme: PropType<"dark" | "light">;
    readonly size: PropType<"small" | "meduim">;
    readonly transitionProps: PropType<string | Record<string, any>>;
    readonly showArrow: BooleanConstructor;
    readonly arrow: PropType<import("../popover").CreateArrow>;
    readonly arrowProps: PropType<Record<string, any>>;
    readonly popoverProps: PropType<Record<string, any>>;
    readonly contentProps: PropType<Record<string, any>>;
    readonly popoverWrapper: PropType<(popup: VNode<import("vue-demi").RendererNode, import("vue-demi").RendererElement, {
        [key: string]: any;
    }>) => VNode<import("vue-demi").RendererNode, import("vue-demi").RendererElement, {
        [key: string]: any;
    }>>;
    readonly onFloatingDataUpdate: PropType<(data: {
        x: number;
        y: number;
        strategy: import("@visoning/vue-floating-core").Strategy;
        placement: import("@visoning/vue-floating-core").Placement;
        middlewareData: {
            [x: string]: any;
            arrow?: {
                x?: number;
                y?: number;
                centerOffset: number;
            };
            autoPlacement?: {
                index?: number;
                overflows: {
                    placement: import("@visoning/vue-floating-core").Placement;
                    overflows: number[];
                }[];
            };
            flip?: {
                index?: number;
                overflows: {
                    placement: import("@visoning/vue-floating-core").Placement;
                    overflows: number[];
                }[];
            };
            hide?: {
                referenceHidden?: boolean;
                escaped?: boolean;
                referenceHiddenOffsets?: {
                    left: number;
                    top: number;
                    bottom: number;
                    right: number;
                };
                escapedOffsets?: {
                    left: number;
                    top: number;
                    bottom: number;
                    right: number;
                };
            };
            offset?: {
                x: number;
                y: number;
            };
            shift?: {
                x: number;
                y: number;
            };
        };
    }) => void>;
    readonly 'onUpdate:open': PropType<(open: boolean, info: import("@visoning/vue-floating-interactions").BaseInteractionInfo<string, Event>) => void>;
    readonly onOpen: PropType<(info: import("@visoning/vue-floating-interactions").BaseInteractionInfo<string, Event>) => void>;
    readonly onClose: PropType<(info: import("@visoning/vue-floating-interactions").BaseInteractionInfo<string, Event>) => void>;
    readonly shift: Omit<{
        type: new (...args: any[]) => (boolean | import("@floating-ui/core").ShiftOptions) & {};
    } | {
        type: () => boolean | import("@floating-ui/core").ShiftOptions;
    } | {
        type: ((new (...args: any[]) => (boolean | import("@floating-ui/core").ShiftOptions) & {}) | (() => boolean | import("@floating-ui/core").ShiftOptions))[];
    }, "default"> & {
        default: true;
    };
    readonly offset: PropType<import("@floating-ui/core").OffsetOptions>;
    readonly active: Omit<{
        type: BooleanConstructor;
    }, "default"> & {
        default: false;
    };
    readonly open: BooleanConstructor;
    readonly zIndex: NumberConstructor;
    readonly disabled: BooleanConstructor;
    readonly reference: {
        type: PropType<import("@visoning/vue-floating-core").ReferenceType>;
    };
    readonly floating: {
        type: PropType<HTMLElement>;
    };
    readonly strategy: Omit<{
        type: new (...args: any[]) => import("@visoning/vue-floating-core").Strategy & {};
    } | {
        type: () => import("@visoning/vue-floating-core").Strategy;
    } | {
        type: ((new (...args: any[]) => import("@visoning/vue-floating-core").Strategy & {}) | (() => import("@visoning/vue-floating-core").Strategy))[];
    }, "default"> & {
        default: "absolute";
    };
    readonly autoPlacement: PropType<boolean | import("@floating-ui/core").AutoPlacementOptions>;
    readonly flip: PropType<boolean | import("@floating-ui/core").FlipOptions>;
    readonly middleware: PropType<import("@visoning/vue-floating-core").Middleware[]>;
    readonly placement: Omit<{
        type: new (...args: any[]) => import("@visoning/vue-floating-core").Placement & {};
    } | {
        type: () => import("@visoning/vue-floating-core").Placement;
    } | {
        type: ((new (...args: any[]) => import("@visoning/vue-floating-core").Placement & {}) | (() => import("@visoning/vue-floating-core").Placement))[];
    }, "default"> & {
        default: "bottom";
    };
    readonly autoUpdate: Omit<{
        type: new (...args: any[]) => (boolean | import("@visoning/vue-floating-core").UseAutoUpdateOptions) & {};
    } | {
        type: () => boolean | import("@visoning/vue-floating-core").UseAutoUpdateOptions;
    } | {
        type: ((new (...args: any[]) => (boolean | import("@visoning/vue-floating-core").UseAutoUpdateOptions) & {}) | (() => boolean | import("@visoning/vue-floating-core").UseAutoUpdateOptions))[];
    }, "default"> & {
        default: true;
    };
    readonly delay: PropType<import("@visoning/vue-floating-interactions").InteractionDelay>;
    readonly interactions: Omit<{
        type: new (...args: any[]) => (false | import("@visoning/vue-floating-interactions").Interaction | import("@visoning/vue-floating-interactions").Interaction[]) & {};
    } | {
        type: () => false | import("@visoning/vue-floating-interactions").Interaction | import("@visoning/vue-floating-interactions").Interaction[];
    } | {
        type: ((new (...args: any[]) => (false | import("@visoning/vue-floating-interactions").Interaction | import("@visoning/vue-floating-interactions").Interaction[]) & {}) | (() => false | import("@visoning/vue-floating-interactions").Interaction | import("@visoning/vue-floating-interactions").Interaction[]))[];
    }, "default"> & {
        default: "hover";
    };
    readonly customInteractions: PropType<((context: import("@visoning/vue-floating-interactions").InteractionsContext<string, Event>) => import("@visoning/vue-utility").MaybeRef<import("@visoning/vue-floating-interactions").ElementProps>)[]>;
    readonly targets: PropType<HTMLElement[]>;
    readonly hoverDelay: PropType<import("@visoning/vue-floating-interactions").InteractionDelay>;
    readonly clickDelay: PropType<import("@visoning/vue-floating-interactions").InteractionDelay>;
    readonly focusDelay: PropType<import("@visoning/vue-floating-interactions").InteractionDelay>;
    readonly allowPointerEnterTarget: Omit<{
        type: BooleanConstructor;
    }, "default"> & {
        default: true;
    };
    readonly inactiveWhenClickOutside: Omit<{
        type: BooleanConstructor;
    }, "default"> & {
        default: true;
    };
    readonly 'onUpdate:active': PropType<(active: boolean, info?: import("@visoning/vue-floating-interactions").BaseInteractionInfo<string, Event>) => void>;
    readonly onActive: PropType<(info?: import("@visoning/vue-floating-interactions").BaseInteractionInfo<string, Event>) => void>;
    readonly onInactive: PropType<(info?: import("@visoning/vue-floating-interactions").BaseInteractionInfo<string, Event>) => void>;
    readonly defaultOpen: Omit<{
        type: BooleanConstructor;
    }, "default"> & {
        default: false;
    };
    readonly virtualElement: PropType<import("@visoning/vue-floating-core").VirtualElement>;
    readonly appendTo: Omit<{
        type: new (...args: any[]) => (string | false | HTMLElement) & {};
    } | {
        type: () => string | false | HTMLElement;
    } | {
        type: ((new (...args: any[]) => (string | false | HTMLElement) & {}) | (() => string | false | HTMLElement))[];
    }, "default"> & {
        default: "viewport";
    };
    readonly autoUpdateOnClosed: BooleanConstructor;
    readonly gpuAcceleration: BooleanConstructor;
    readonly destoryedOnClosed: BooleanConstructor;
    readonly floatingProps: PropType<Record<string, any>>;
    readonly floatingWrapper: PropType<(popup: VNode<import("vue-demi").RendererNode, import("vue-demi").RendererElement, {
        [key: string]: any;
    }>) => VNode<import("vue-demi").RendererNode, import("vue-demi").RendererElement, {
        [key: string]: any;
    }>>;
    readonly popupProps: PropType<Record<string, any>>;
    readonly popupWrapper: PropType<(popup: VNode<import("vue-demi").RendererNode, import("vue-demi").RendererElement, {
        [key: string]: any;
    }>) => VNode<import("vue-demi").RendererNode, import("vue-demi").RendererElement, {
        [key: string]: any;
    }>>;
}, {
    readonly theme: "line";
    readonly size: "meduim";
    readonly transitionProps: "visoning-popover";
    readonly showArrow: true;
}>, "shift" | "offset" | "active" | "open" | "content" | "zIndex" | "title" | "disabled" | "size" | "reference" | "floating" | "strategy" | "arrow" | "autoPlacement" | "flip" | "middleware" | "placement" | "autoUpdate" | "delay" | "interactions" | "customInteractions" | "targets" | "hoverDelay" | "clickDelay" | "focusDelay" | "allowPointerEnterTarget" | "inactiveWhenClickOutside" | "onUpdate:active" | "onActive" | "onInactive" | "onFloatingDataUpdate" | "defaultOpen" | "virtualElement" | "appendTo" | "autoUpdateOnClosed" | "gpuAcceleration" | "destoryedOnClosed" | "floatingProps" | "floatingWrapper" | "popupProps" | "popupWrapper" | "onUpdate:open" | "onOpen" | "onClose" | "theme" | "transitionProps" | "showArrow" | "arrowProps" | "popoverProps" | "contentProps" | "popoverWrapper">;
export declare const TooltipPropsType: {
    /**
     * align tooltip content. enum of CSS text-align.
     * @default 'start'
     */
    readonly textAlign: PropType<"center" | "end" | "start" | "left" | "right" | "justify" | "match-parent">;
    /**
     * HTML attributes of node.
     */
    readonly tooltipProps: PropType<Record<string, any>>;
    /**
     * Custom tooltip node wrapper.
     */
    readonly tooltipWrapper: PropType<(popup: VNode | null) => VNode>;
    readonly onFloatingDataUpdate: PropType<(data: {
        x: number;
        y: number;
        strategy: import("@visoning/vue-floating-core").Strategy;
        placement: import("@visoning/vue-floating-core").Placement;
        middlewareData: {
            [x: string]: any;
            arrow?: {
                x?: number;
                y?: number;
                centerOffset: number;
            };
            autoPlacement?: {
                index?: number;
                overflows: {
                    placement: import("@visoning/vue-floating-core").Placement;
                    overflows: number[];
                }[];
            };
            flip?: {
                index?: number;
                overflows: {
                    placement: import("@visoning/vue-floating-core").Placement;
                    overflows: number[];
                }[];
            };
            hide?: {
                referenceHidden?: boolean;
                escaped?: boolean;
                referenceHiddenOffsets?: {
                    left: number;
                    top: number;
                    bottom: number;
                    right: number;
                };
                escapedOffsets?: {
                    left: number;
                    top: number;
                    bottom: number;
                    right: number;
                };
            };
            offset?: {
                x: number;
                y: number;
            };
            shift?: {
                x: number;
                y: number;
            };
        };
    }) => void>;
    readonly 'onUpdate:open': PropType<(open: boolean, info: import("@visoning/vue-floating-interactions").BaseInteractionInfo<string, Event>) => void>;
    readonly onOpen: PropType<(info: import("@visoning/vue-floating-interactions").BaseInteractionInfo<string, Event>) => void>;
    readonly onClose: PropType<(info: import("@visoning/vue-floating-interactions").BaseInteractionInfo<string, Event>) => void>;
    readonly shift: Omit<{
        type: new (...args: any[]) => (boolean | import("@floating-ui/core").ShiftOptions) & {};
    } | {
        type: () => boolean | import("@floating-ui/core").ShiftOptions;
    } | {
        type: ((new (...args: any[]) => (boolean | import("@floating-ui/core").ShiftOptions) & {}) | (() => boolean | import("@floating-ui/core").ShiftOptions))[];
    }, "default"> & {
        default: true;
    };
    readonly offset: PropType<import("@floating-ui/core").OffsetOptions>;
    readonly active: Omit<{
        type: BooleanConstructor;
    }, "default"> & {
        default: false;
    };
    readonly open: BooleanConstructor;
    readonly content: PropType<string | (() => VNode<import("vue-demi").RendererNode, import("vue-demi").RendererElement, {
        [key: string]: any;
    }>)>;
    readonly zIndex: NumberConstructor;
    readonly title: PropType<string | (() => VNode<import("vue-demi").RendererNode, import("vue-demi").RendererElement, {
        [key: string]: any;
    }>)>;
    readonly disabled: BooleanConstructor;
    readonly size: Omit<{
        type: new (...args: any[]) => ("small" | "meduim") & {};
    } | {
        type: () => "small" | "meduim";
    } | {
        type: ((new (...args: any[]) => ("small" | "meduim") & {}) | (() => "small" | "meduim"))[];
    }, "default"> & {
        default: "meduim";
    };
    readonly reference: {
        type: PropType<import("@visoning/vue-floating-core").ReferenceType>;
    };
    readonly floating: {
        type: PropType<HTMLElement>;
    };
    readonly strategy: Omit<{
        type: new (...args: any[]) => import("@visoning/vue-floating-core").Strategy & {};
    } | {
        type: () => import("@visoning/vue-floating-core").Strategy;
    } | {
        type: ((new (...args: any[]) => import("@visoning/vue-floating-core").Strategy & {}) | (() => import("@visoning/vue-floating-core").Strategy))[];
    }, "default"> & {
        default: "absolute";
    };
    readonly arrow: PropType<import("../popover").CreateArrow>;
    readonly autoPlacement: PropType<boolean | import("@floating-ui/core").AutoPlacementOptions>;
    readonly flip: PropType<boolean | import("@floating-ui/core").FlipOptions>;
    readonly middleware: PropType<import("@visoning/vue-floating-core").Middleware[]>;
    readonly placement: Omit<{
        type: new (...args: any[]) => import("@visoning/vue-floating-core").Placement & {};
    } | {
        type: () => import("@visoning/vue-floating-core").Placement;
    } | {
        type: ((new (...args: any[]) => import("@visoning/vue-floating-core").Placement & {}) | (() => import("@visoning/vue-floating-core").Placement))[];
    }, "default"> & {
        default: "bottom";
    };
    readonly autoUpdate: Omit<{
        type: new (...args: any[]) => (boolean | import("@visoning/vue-floating-core").UseAutoUpdateOptions) & {};
    } | {
        type: () => boolean | import("@visoning/vue-floating-core").UseAutoUpdateOptions;
    } | {
        type: ((new (...args: any[]) => (boolean | import("@visoning/vue-floating-core").UseAutoUpdateOptions) & {}) | (() => boolean | import("@visoning/vue-floating-core").UseAutoUpdateOptions))[];
    }, "default"> & {
        default: true;
    };
    readonly delay: PropType<import("@visoning/vue-floating-interactions").InteractionDelay>;
    readonly interactions: Omit<{
        type: new (...args: any[]) => (false | import("@visoning/vue-floating-interactions").Interaction | import("@visoning/vue-floating-interactions").Interaction[]) & {};
    } | {
        type: () => false | import("@visoning/vue-floating-interactions").Interaction | import("@visoning/vue-floating-interactions").Interaction[];
    } | {
        type: ((new (...args: any[]) => (false | import("@visoning/vue-floating-interactions").Interaction | import("@visoning/vue-floating-interactions").Interaction[]) & {}) | (() => false | import("@visoning/vue-floating-interactions").Interaction | import("@visoning/vue-floating-interactions").Interaction[]))[];
    }, "default"> & {
        default: "hover";
    };
    readonly customInteractions: PropType<((context: import("@visoning/vue-floating-interactions").InteractionsContext<string, Event>) => import("@visoning/vue-utility").MaybeRef<import("@visoning/vue-floating-interactions").ElementProps>)[]>;
    readonly targets: PropType<HTMLElement[]>;
    readonly hoverDelay: PropType<import("@visoning/vue-floating-interactions").InteractionDelay>;
    readonly clickDelay: PropType<import("@visoning/vue-floating-interactions").InteractionDelay>;
    readonly focusDelay: PropType<import("@visoning/vue-floating-interactions").InteractionDelay>;
    readonly allowPointerEnterTarget: Omit<{
        type: BooleanConstructor;
    }, "default"> & {
        default: true;
    };
    readonly inactiveWhenClickOutside: Omit<{
        type: BooleanConstructor;
    }, "default"> & {
        default: true;
    };
    readonly 'onUpdate:active': PropType<(active: boolean, info?: import("@visoning/vue-floating-interactions").BaseInteractionInfo<string, Event>) => void>;
    readonly onActive: PropType<(info?: import("@visoning/vue-floating-interactions").BaseInteractionInfo<string, Event>) => void>;
    readonly onInactive: PropType<(info?: import("@visoning/vue-floating-interactions").BaseInteractionInfo<string, Event>) => void>;
    readonly defaultOpen: Omit<{
        type: BooleanConstructor;
    }, "default"> & {
        default: false;
    };
    readonly virtualElement: PropType<import("@visoning/vue-floating-core").VirtualElement>;
    readonly appendTo: Omit<{
        type: new (...args: any[]) => (string | false | HTMLElement) & {};
    } | {
        type: () => string | false | HTMLElement;
    } | {
        type: ((new (...args: any[]) => (string | false | HTMLElement) & {}) | (() => string | false | HTMLElement))[];
    }, "default"> & {
        default: "viewport";
    };
    readonly autoUpdateOnClosed: BooleanConstructor;
    readonly gpuAcceleration: BooleanConstructor;
    readonly destoryedOnClosed: BooleanConstructor;
    readonly floatingProps: PropType<Record<string, any>>;
    readonly floatingWrapper: PropType<(popup: VNode<import("vue-demi").RendererNode, import("vue-demi").RendererElement, {
        [key: string]: any;
    }>) => VNode<import("vue-demi").RendererNode, import("vue-demi").RendererElement, {
        [key: string]: any;
    }>>;
    readonly popupProps: PropType<Record<string, any>>;
    readonly popupWrapper: PropType<(popup: VNode<import("vue-demi").RendererNode, import("vue-demi").RendererElement, {
        [key: string]: any;
    }>) => VNode<import("vue-demi").RendererNode, import("vue-demi").RendererElement, {
        [key: string]: any;
    }>>;
    readonly theme: Omit<{
        type: new (...args: any[]) => ("dark" | "light") & {};
    } | {
        type: () => "dark" | "light";
    } | {
        type: ((new (...args: any[]) => ("dark" | "light") & {}) | (() => "dark" | "light"))[];
    }, "default"> & {
        default: "line";
    };
    readonly transitionProps: Omit<{
        type: new (...args: any[]) => (string | Record<string, any>) & {};
    } | {
        type: () => string | Record<string, any>;
    } | {
        type: ((new (...args: any[]) => (string | Record<string, any>) & {}) | (() => string | Record<string, any>))[];
    }, "default"> & {
        default: "visoning-popover";
    };
    readonly showArrow: Omit<{
        type: BooleanConstructor;
    }, "default"> & {
        default: true;
    };
    readonly arrowProps: PropType<Record<string, any>>;
    readonly popoverProps: PropType<Record<string, any>>;
    readonly contentProps: PropType<Record<string, any>>;
    readonly popoverWrapper: PropType<(popup: VNode<import("vue-demi").RendererNode, import("vue-demi").RendererElement, {
        [key: string]: any;
    }>) => VNode<import("vue-demi").RendererNode, import("vue-demi").RendererElement, {
        [key: string]: any;
    }>>;
};
export declare const TooltipDefaultProps: {
    readonly interactions: "hover";
    readonly theme: "drak";
    readonly textAlign: "start";
};
export declare const TooltipProps: import("@visoning/vue-utility").WithDefaultProps<{
    /**
     * align tooltip content. enum of CSS text-align.
     * @default 'start'
     */
    readonly textAlign: PropType<"center" | "end" | "start" | "left" | "right" | "justify" | "match-parent">;
    /**
     * HTML attributes of node.
     */
    readonly tooltipProps: PropType<Record<string, any>>;
    /**
     * Custom tooltip node wrapper.
     */
    readonly tooltipWrapper: PropType<(popup: VNode | null) => VNode>;
    readonly onFloatingDataUpdate: PropType<(data: {
        x: number;
        y: number;
        strategy: import("@visoning/vue-floating-core").Strategy;
        placement: import("@visoning/vue-floating-core").Placement;
        middlewareData: {
            [x: string]: any;
            arrow?: {
                x?: number;
                y?: number;
                centerOffset: number;
            };
            autoPlacement?: {
                index?: number;
                overflows: {
                    placement: import("@visoning/vue-floating-core").Placement;
                    overflows: number[];
                }[];
            };
            flip?: {
                index?: number;
                overflows: {
                    placement: import("@visoning/vue-floating-core").Placement;
                    overflows: number[];
                }[];
            };
            hide?: {
                referenceHidden?: boolean;
                escaped?: boolean;
                referenceHiddenOffsets?: {
                    left: number;
                    top: number;
                    bottom: number;
                    right: number;
                };
                escapedOffsets?: {
                    left: number;
                    top: number;
                    bottom: number;
                    right: number;
                };
            };
            offset?: {
                x: number;
                y: number;
            };
            shift?: {
                x: number;
                y: number;
            };
        };
    }) => void>;
    readonly 'onUpdate:open': PropType<(open: boolean, info: import("@visoning/vue-floating-interactions").BaseInteractionInfo<string, Event>) => void>;
    readonly onOpen: PropType<(info: import("@visoning/vue-floating-interactions").BaseInteractionInfo<string, Event>) => void>;
    readonly onClose: PropType<(info: import("@visoning/vue-floating-interactions").BaseInteractionInfo<string, Event>) => void>;
    readonly shift: Omit<{
        type: new (...args: any[]) => (boolean | import("@floating-ui/core").ShiftOptions) & {};
    } | {
        type: () => boolean | import("@floating-ui/core").ShiftOptions;
    } | {
        type: ((new (...args: any[]) => (boolean | import("@floating-ui/core").ShiftOptions) & {}) | (() => boolean | import("@floating-ui/core").ShiftOptions))[];
    }, "default"> & {
        default: true;
    };
    readonly offset: PropType<import("@floating-ui/core").OffsetOptions>;
    readonly active: Omit<{
        type: BooleanConstructor;
    }, "default"> & {
        default: false;
    };
    readonly open: BooleanConstructor;
    readonly content: PropType<string | (() => VNode<import("vue-demi").RendererNode, import("vue-demi").RendererElement, {
        [key: string]: any;
    }>)>;
    readonly zIndex: NumberConstructor;
    readonly title: PropType<string | (() => VNode<import("vue-demi").RendererNode, import("vue-demi").RendererElement, {
        [key: string]: any;
    }>)>;
    readonly disabled: BooleanConstructor;
    readonly size: Omit<{
        type: new (...args: any[]) => ("small" | "meduim") & {};
    } | {
        type: () => "small" | "meduim";
    } | {
        type: ((new (...args: any[]) => ("small" | "meduim") & {}) | (() => "small" | "meduim"))[];
    }, "default"> & {
        default: "meduim";
    };
    readonly reference: {
        type: PropType<import("@visoning/vue-floating-core").ReferenceType>;
    };
    readonly floating: {
        type: PropType<HTMLElement>;
    };
    readonly strategy: Omit<{
        type: new (...args: any[]) => import("@visoning/vue-floating-core").Strategy & {};
    } | {
        type: () => import("@visoning/vue-floating-core").Strategy;
    } | {
        type: ((new (...args: any[]) => import("@visoning/vue-floating-core").Strategy & {}) | (() => import("@visoning/vue-floating-core").Strategy))[];
    }, "default"> & {
        default: "absolute";
    };
    readonly arrow: PropType<import("../popover").CreateArrow>;
    readonly autoPlacement: PropType<boolean | import("@floating-ui/core").AutoPlacementOptions>;
    readonly flip: PropType<boolean | import("@floating-ui/core").FlipOptions>;
    readonly middleware: PropType<import("@visoning/vue-floating-core").Middleware[]>;
    readonly placement: Omit<{
        type: new (...args: any[]) => import("@visoning/vue-floating-core").Placement & {};
    } | {
        type: () => import("@visoning/vue-floating-core").Placement;
    } | {
        type: ((new (...args: any[]) => import("@visoning/vue-floating-core").Placement & {}) | (() => import("@visoning/vue-floating-core").Placement))[];
    }, "default"> & {
        default: "bottom";
    };
    readonly autoUpdate: Omit<{
        type: new (...args: any[]) => (boolean | import("@visoning/vue-floating-core").UseAutoUpdateOptions) & {};
    } | {
        type: () => boolean | import("@visoning/vue-floating-core").UseAutoUpdateOptions;
    } | {
        type: ((new (...args: any[]) => (boolean | import("@visoning/vue-floating-core").UseAutoUpdateOptions) & {}) | (() => boolean | import("@visoning/vue-floating-core").UseAutoUpdateOptions))[];
    }, "default"> & {
        default: true;
    };
    readonly delay: PropType<import("@visoning/vue-floating-interactions").InteractionDelay>;
    readonly interactions: Omit<{
        type: new (...args: any[]) => (false | import("@visoning/vue-floating-interactions").Interaction | import("@visoning/vue-floating-interactions").Interaction[]) & {};
    } | {
        type: () => false | import("@visoning/vue-floating-interactions").Interaction | import("@visoning/vue-floating-interactions").Interaction[];
    } | {
        type: ((new (...args: any[]) => (false | import("@visoning/vue-floating-interactions").Interaction | import("@visoning/vue-floating-interactions").Interaction[]) & {}) | (() => false | import("@visoning/vue-floating-interactions").Interaction | import("@visoning/vue-floating-interactions").Interaction[]))[];
    }, "default"> & {
        default: "hover";
    };
    readonly customInteractions: PropType<((context: import("@visoning/vue-floating-interactions").InteractionsContext<string, Event>) => import("@visoning/vue-utility").MaybeRef<import("@visoning/vue-floating-interactions").ElementProps>)[]>;
    readonly targets: PropType<HTMLElement[]>;
    readonly hoverDelay: PropType<import("@visoning/vue-floating-interactions").InteractionDelay>;
    readonly clickDelay: PropType<import("@visoning/vue-floating-interactions").InteractionDelay>;
    readonly focusDelay: PropType<import("@visoning/vue-floating-interactions").InteractionDelay>;
    readonly allowPointerEnterTarget: Omit<{
        type: BooleanConstructor;
    }, "default"> & {
        default: true;
    };
    readonly inactiveWhenClickOutside: Omit<{
        type: BooleanConstructor;
    }, "default"> & {
        default: true;
    };
    readonly 'onUpdate:active': PropType<(active: boolean, info?: import("@visoning/vue-floating-interactions").BaseInteractionInfo<string, Event>) => void>;
    readonly onActive: PropType<(info?: import("@visoning/vue-floating-interactions").BaseInteractionInfo<string, Event>) => void>;
    readonly onInactive: PropType<(info?: import("@visoning/vue-floating-interactions").BaseInteractionInfo<string, Event>) => void>;
    readonly defaultOpen: Omit<{
        type: BooleanConstructor;
    }, "default"> & {
        default: false;
    };
    readonly virtualElement: PropType<import("@visoning/vue-floating-core").VirtualElement>;
    readonly appendTo: Omit<{
        type: new (...args: any[]) => (string | false | HTMLElement) & {};
    } | {
        type: () => string | false | HTMLElement;
    } | {
        type: ((new (...args: any[]) => (string | false | HTMLElement) & {}) | (() => string | false | HTMLElement))[];
    }, "default"> & {
        default: "viewport";
    };
    readonly autoUpdateOnClosed: BooleanConstructor;
    readonly gpuAcceleration: BooleanConstructor;
    readonly destoryedOnClosed: BooleanConstructor;
    readonly floatingProps: PropType<Record<string, any>>;
    readonly floatingWrapper: PropType<(popup: VNode<import("vue-demi").RendererNode, import("vue-demi").RendererElement, {
        [key: string]: any;
    }>) => VNode<import("vue-demi").RendererNode, import("vue-demi").RendererElement, {
        [key: string]: any;
    }>>;
    readonly popupProps: PropType<Record<string, any>>;
    readonly popupWrapper: PropType<(popup: VNode<import("vue-demi").RendererNode, import("vue-demi").RendererElement, {
        [key: string]: any;
    }>) => VNode<import("vue-demi").RendererNode, import("vue-demi").RendererElement, {
        [key: string]: any;
    }>>;
    readonly theme: Omit<{
        type: new (...args: any[]) => ("dark" | "light") & {};
    } | {
        type: () => "dark" | "light";
    } | {
        type: ((new (...args: any[]) => ("dark" | "light") & {}) | (() => "dark" | "light"))[];
    }, "default"> & {
        default: "line";
    };
    readonly transitionProps: Omit<{
        type: new (...args: any[]) => (string | Record<string, any>) & {};
    } | {
        type: () => string | Record<string, any>;
    } | {
        type: ((new (...args: any[]) => (string | Record<string, any>) & {}) | (() => string | Record<string, any>))[];
    }, "default"> & {
        default: "visoning-popover";
    };
    readonly showArrow: Omit<{
        type: BooleanConstructor;
    }, "default"> & {
        default: true;
    };
    readonly arrowProps: PropType<Record<string, any>>;
    readonly popoverProps: PropType<Record<string, any>>;
    readonly contentProps: PropType<Record<string, any>>;
    readonly popoverWrapper: PropType<(popup: VNode<import("vue-demi").RendererNode, import("vue-demi").RendererElement, {
        [key: string]: any;
    }>) => VNode<import("vue-demi").RendererNode, import("vue-demi").RendererElement, {
        [key: string]: any;
    }>>;
}, {
    readonly interactions: "hover";
    readonly theme: "drak";
    readonly textAlign: "start";
}>;
export declare type TooltipProps = ExtractPropTypes<typeof TooltipProps>;
